REM ----------------------------------------------------------------------------------------------------------------
REM THE PB/WIN 10 SOURCE CODE FOR MELGO by Ribeiro Alvo
REM ----------------------------------------------------------------------------------------------------------------
#ALIGN 128
#OPTIMIZE SPEED

#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "Win32Api.inc"

#RESOURCE ICON 100,"Melgo.ico"
#RESOURCE VERSIONINFO
#RESOURCE FILEVERSION 61, 0, 0, 0
#RESOURCE PRODUCTVERSION 61, 0, 0, 0
#RESOURCE STRINGINFO "0409", "04B0"
#RESOURCE VERSION$ "Comments",         "New way to encrypt files"
#RESOURCE VERSION$ "CompanyName",      "Ribeiro Alvo"
#RESOURCE VERSION$ "FileDescription",  "Encrypt files"
#RESOURCE VERSION$ "FileVersion",      "Versiom 61"
#RESOURCE VERSION$ "InternalName",     "Melgo"
#RESOURCE VERSION$ "LegalCopyright",   "Ribeiro Alvo (c) 2018"
#RESOURCE VERSION$ "OriginalFilename", "Melgo.exe"
#RESOURCE VERSION$ "ProductName",      "Melgo"
#RESOURCE VERSION$ "ProductVersion",   "61"

GLOBAL MousePoint AS POINTAPI
GLOBAL lb,hWin,hVin AS LONG

DECLARE FUNCTION GCD LIB "Kernel32.dll"  ALIAS "GetCurrentDirectoryW" (BYVAL nBufferLength AS DWORD, lpBuffer AS WSTRINGZ) AS DWORD

FUNCTION PBMAIN ()

 LOCAL Cudi AS WSTRINGZ * 2048
 LOCAL nRet AS LONG
 nret =  gcd (2048,Cudi)


LOCAL somachar,somabit,totalbits,pii,somacorrel1,somacorrel2,oldfoldtime,fola AS QUAD
LOCAL num,i,tss,sizeold,posbyte,posbyteold,oldposbyte,m,maxfreq AS QUAD
LOCAL LerWriteTime, StatWriteTime AS QUAD
LOCAL blksize,hDlg,xsizi,ysizi,xsize,ysize,corp,ust,ist,ustold,fileold AS LONG
LOCAL fhndl,corbut2,corcai,p,ide,cori,coru,iold,corlixo,fileposi,oldfileposi,filant AS LONG
LOCAL pap,corbu,corbut1,corqua,fu,plinold,oldmouse,oldcorlixo,hBmp AS LONG
LOCAL ftop,ftop1,fbot,fuc,ii,crypt,cryptold,nbit,nbitold,plin,mtp AS LONG
LOCAL uu,nWidth, nHeight,px1,px2,py1,px1old,px2old,py1old,nflot,nflotold AS LONG
LOCAL u,blkk,posbit,ndirs,nfiles,plk,xtex,ytex,piu,rodacor,utu AS LONG
LOCAL k,ky,block,men,oldmen,clio,lt,ltold,ly,lyp,nch AS STRING
LOCAL comptime,filememstat,filememler,scha,memem,snbit,version,cap,showed AS STRING
LOCAL entropy,montecarlopi,chi,correl,media,cont,oldcont,hbmpSource,rd,tempo,fx,fy,fz AS EXT
LOCAL hStatic,contbit1,contbit1old,nfloats,adr,mold,cump,posinix,posiniy,hicon,hfile AS DWORD
LOCAL piq,oldpos,compmax,tam,ded,totfreq,hHoleRgn AS DWORD
LOCAL desc,tex,bti,ic,uc,tlin,desl,altura,ud,ini AS BYTE
LOCAL altu,altlin,idesl,cat,oldcat,lnbit,lim,xlarg,integral AS BYTE
LOCAL yalt,yat,yat1,yat2,xat,t1,cha,erra,qz,linclar,proc,conti,contfile,nm AS BYTE
LOCAL pg,a,b,c,iu,mfp,mfpold AS WORD
LOCAL posy0,posy1,slin,n AS WORD
LOCAL oldfile,tipo,oldname,oldstatfile,oldstatdir AS WSTRING
LOCAL bir,temp,oldir,oldlerfile,oldu,nome AS WSTRING
LOCAL posblk AS DOUBLE
LOCAL vbit,ux AS SINGLE
LOCAL rc AS RECT


tipo="Arial Unicode MS"
LOCAL Built AS IPOWERTIME
LET Built = CLASS "PowerTime"
Built.Filetime=%PB_COMPILETIME
comptime=STR$(Built.Year)+" "+MONTHNAME$(Built.Month)+STR$(Built.Day)+" at"+STR$(Built.Hour)+" hours and"+STR$(Built.Minute)+" minutes"

version="61"
cap="Melgo "+version+"  Ribeiro Alvo"
fu=-1
piq=255*255
cat=0
oldcat=1

m=2^62
n=2^16-1 REM <- (0 to 65535 = 65536) * (56 bit) keys = 3 670 016  bits
nfloats=50000

DIM fw(51001) AS EXT
DIM stn(265) AS WSTRING
DIM str(265) AS STRING
DIM stc(8) AS STRING

DIM tn(12) AS WSTRINGZ*10
DIM an(20) AS WORD
DIM vk(10) AS STRINGZ*3
DIM sh() AS BYTE
DIM corkey(1) AS LONG

DIM car(255) AS WSTRINGZ*40
DIM aju(25) AS STRINGZ*200
DIM mensagem (4) AS WSTRING
DIM valor(1) AS STRING
DIM cof(2) AS LONG
DIM corfile (1) AS LONG
DIM x(n) AS LOCAL QUAD
DIM corbit(1) AS LONG
DIM ru(265) AS BYTE
DIM re(8) AS BYTE
DIM ri(1) AS WSTRING*1
DIM cryval(1) AS WSTRINGZ*10
ri(0)=CHR$$(&h2715)
ri(1)=CHR$$(&h2713)
valor(0)="Encrypt"
valor(1)="Decrypt"

DIM freqchar(255) AS QUAD
DIM bitum(0 TO 255) AS BYTE
DIM posdir(50000) AS WORD, cam(10000) AS WSTRING
DIM bina(255) AS STRING*8
RANDOMIZE TIMER
pg=100

ftop=&HD3D3D3
rodacor=ftop
ftop1=ftop
fuc=0

cryval(0)="Enc"
cryval(1)="Dec"

corkey(0)=%RGB_DIMGRAY
corkey(1)=%RGB_LIGHTGRAY

corbut1=ftop
corfile(0)=fuc
corfile(1)=&HFFFFFF
corfile(2)=&Ha6adb5

corbut2=fuc
cof(0)=corbut2
cof(1)=ftop
cof(2)=corfile(1)

stn(0)="Bytes in file"
stn(1)="Entropy"
stn(2)="Chi Square "+CHR$$(&h3C7,&hB2)
stn(3)="Aritmetic Mean "+CHR$$(&h3BC)
stn(4)="Monte Carlo "+CHR$$(&h3C0)
stn(5)="Serial Correlation"
stn(6)="Bits off"
stn(7)="Bits on"
stn(8)="Frequence"

tn(0)="Home"
tn(1)="Up"
tn(2)="PgUp"
tn(3)="BkSp"
tn(4)="Del"
tn(5)="Find"
tn(6)="End"
tn(7)="Down"
tn(8)="PgDn"
tn(9)="Rnd"
tn(10)="Hide"

altura=23
pap=1

Aju(1)=  "An open source for a small application to encrypt files with a new and save algorithm with very good performance"
Aju(2)=  "Version "+version+" Updated on"+comptime
Aju(4)=  "The empty left side of the bar - Hides the larger window below the menu bar. Esc"
Aju(5)=  "Browse files and folders. Search with F2 for folders F3 for decrypted files F4 for encrypted files. Enter to open selected folder or to encrypt/decrypt selected file"
Aju(6)=  "Go down in tree/Back in files path - BackSpace"
Aju(7)=  "Encrypt or decrypt the selected file with 65 536 keys of 56 bit each one = 3 670 016 bits. Enter or left mouse button down on display to put shown bit on | off"
Aju(8)=   SPACE$(18)+"SpaceBar to find the bits on. Del to reset all bits (No key). After select the key, press the Enc | Dec button"
Aju(9)=  "Find encrypted files on the selected folder, if any. A small white square is shown for each encrypted file"
Aju(10)= "Shown selected file statistics. Scroll keys or left mouse button to see the byte frequences"
Aju(11)= "Generate 50 000 pseudo random numbers in (0,1) to memory. Use Ctrl+V to paste them to other applications"
Aju(12)= "Shows the selected file contents or change to the selected folder"
Aju(13)=  SPACE$(18)+"Black or white square, show the file contents and byte positions. Scroll keys or right mouse button to browse the file. Gray square, open the selected folder"
Aju(14)= "Minimize the window"
Aju(15)= "This window - Information and instructions F1"
Aju(16)= "Permanently erases the selected file with 10 rewrite cycles. Del key or press the left button on the trash can"
Aju(17)= "Close and exit this application. Alt + F4"
Aju(19)= "Files will be lost forever if decrypted with a wrong key or a different version of Melgo. Earlier versions are discontinued"
Aju(20)= "Algorithm description can be seen here - http://www.number.com.pt/Melgo.html  Contact and/or support: ribeiroalvo@sapo.pt"

car(0)= "NUL Null"
car(1)= "SOH Start Of Heading"
car(2)= "STX Start Of Text"
car(3)= "ETX End Of Text"
car(4)= "EOT End Of Transmission"
car(5)= "ENQ Enquiry"
car(6)= "ACK Acknowledge"
car(7)= "BEL Bell"
car(8)= "BS Backspace"
car(9)= "TAB Horizontal Tab"
car(10)="LF Line Feed New line"
car(11)="VT Vertical Tab"
car(12)="FF Form Feed New page"
car(13)="CR Carriage Return"
car(14)="SO Shift Out"
car(15)="SI Shift In"
car(16)="DLE Data Link Escape"
car(17)="DC1 Device Control 1"
car(18)="DC2 Device Control 2"
car(19)="DC3 Device Control 3"
car(20)="DC4 Device Control 4"
car(21)="NAK Negative Acknowledge"
car(22)="SYN Synchronous Idle"
car(23)="ETB End of Transmission block"
car(24)="CAN Cancel"
car(25)="EM End of Medium"
car(26)="SUB Substitute"
car(27)="ESC Escape"
car(28)="FS File Separator"
car(29)="GS Groupe Separator"
car(30)="RS Record Separator"
car(31)="US Unit Separator"
car(32)="SPC Space"

mtp=100000
DIM w(mtp) AS BYTE
DIM Listing(mtp) AS DIRDATA
DIM CurFold AS DIRDATA
DIM CurFile AS DIRDATA

DESKTOP GET CLIENT TO xsizi, ysizi

xsize=1074
ysize=540
posinix=(xsizi-xsize)/2
posiniy=(ysizi-ysize)/2

hicon = loadicon(%NULL, BYVAL %IDI_APPLICATION)


GRAPHIC WINDOW NEW "", posinix, posiniy, xsize, ysize TO hWin
GRAPHIC SET CAPTION cap

SendMessage hWin, %WM_SETICON, %ICON_SMALL, hIcon

fbot=%GRAY
GRAPHIC CLEAR fbot
GRAPHIC COLOR fbot,fbot


LOCAL hThread AS DWORD
THREAD CREATE RedrawGraphics (hWin) TO hThread

hStatic = GetWindow(hWin, %GW_CHILD)
SetProp hWin, "OldStaticProc", SetWindowLong(hStatic, %GWL_WNDPROC, CODEPTR(StaticProc))

GRAPHIC LINE (-4,56)-(xsize,56),%RGB_DIMGRAY
GRAPHIC LINE (-4,61)-(xsize,61),%RGB_DIMGRAY

ftop=fbot


FONT NEW tipo,8,0,0,0,0 TO fhndl
GRAPHIC SET FONT fhndl


compmax=xsize-50
GOSUB findfiles
GOSUB makemenu
cam(0)=cudi
posdir(0)=fileposi


FOR ii=0 TO 255
 bina(ii)=RIGHT$("00000000"+BIN$(ii),8)
 IF ii>32 THEN  car(ii)=CHR$(ii)
 bir=BIN$(ii)
 FOR u=1 TO LEN(bir)
  IF MID$(bir,u,1)="1" THEN INCR bitum(ii)
 NEXT
NEXT
car(127)="DEL (Delete)"
corbit(0)=corfile(1)
corbit(1)=corfile(0)

plk=4

   vk(0)=" G"
   vk(1)=" H"
   vk(2)=" I"
   vk(3)=$BS
   vk(4)=" S"
   vk(5)=" "
   vk(6)=" O"
   vk(7)=" P"
   vk(8)=" Q"

GOTO escapar

REM ----------------------------------------------------------------------------------------------------------------
NODO:

DO
 GOSUB espera

NODO1:

men=""

 IF k=$BS AND LEN(cudi)=>3 THEN
  FOR ded=0 TO 1000
   IF LCASE$(cudi)=LCASE$(cam(ded)) THEN EXIT FOR
  NEXT
  posdir(ded)=fileposi

  oldir=PATHNAME$ (NAME ,cudi)

  IF INSTR(oldir,"~") THEN
   CHDIR ".."
   GOSUB findfiles
   FOR i=0 TO mfp
     IF UCASE$(oldir)=UCASE$(Listing(i).ShortName) THEN
      REPLACE oldir WITH Listing(i).FileName IN cudi
      cudi=cudi+"\"+Listing(i).FileName
      GOTO plr
     END IF
   NEXT

   plr:
   FOR u=0 TO 1000
    IF cam(u)="" THEN EXIT
    IF cam(u)<>"" AND INSTR(cam(u),"~")>0 THEN REPLACE oldir WITH Listing(i).FileName IN cam(u)
   NEXT
  END IF

  FOR ded=0 TO 1000
   IF LCASE$(cudi)=LCASE$(cam(ded)) THEN EXIT FOR
  NEXT
  posdir(ded)=fileposi
  cam(ded)=cudi

  cont=0
  ly="":lyp=""
  k="":ky=""

  IF mensagem(1)<>"Folder with inaccessible content" THEN CHDIR LEFT$(cudi,INSTR(-1,cudi, "\"))
  cudi=CURDIR$
  IF INSTR(cudi,"~")>0 THEN REPLACE oldir WITH Listing(i).FileName IN cudi

  FOR ded=0 TO 1000
   IF UCASE$(cudi)=UCASE$(cam(ded)) OR cam(ded)="" THEN EXIT FOR
  NEXT
  cam(ded)=cudi
  fileposi=posdir(ded)

  GOSUB findfiles

 IF fileposi<>0 THEN xnm
  IF fileposi=0 THEN
   FOR i=0 TO mfp-1
     IF UCASE$(listing(i).filename) = UCASE$(oldir) OR UCASE$(listing(i).shortname) = UCASE$(oldir) THEN corre
   NEXT

  i=0:fileposi=0:GOTO xnm
  corre:

    FOR i=0 TO mfp-1
     IF UCASE$(listing(i).filename) = UCASE$(oldir) OR UCASE$(listing(i).shortname) = UCASE$(oldir) THEN EXIT FOR
    NEXT
  END IF
  fileposi=i

     xnm:

  IF mensagem(1)="Folder with inaccessible content" THEN
    fileposi=oldfileposi
    oldcat=0
    GOTO lista
  END IF


   cat=w(fileposi)
   IF w(fileposi) MOD 2=0 AND cat<>oldcat THEN GOSUB filetype

   GOSUB escremen
   IF k=$BS AND mfp=0 THEN nodo1
   k="":ky=""
   IF mensagem(1)="Empty folder" THEN lista
   IF mfp>3708 THEN listu
   GOTO lista
 END IF

LOOP

REM ----------------------------------------------------------------------------------------------------------------
LISTA:
   linclar=0

 IF showed<>"lista" THEN GOSUB limpa:oldir=""

 IF mfp=0 THEN
   vazio:
   mfpold=mfp
  GOSUB limpa
  cont=0
  mensagem(0)=cudi
  mensagem(1)="Empty folder"
  GOSUB escremen
  GOTO wpl
 END IF
  showed="lista"

 IF mfp<>mfpold THEN oldir="":mfpold=mfp
 IF oldu=cudi THEN listu

 IF Cudi<>oldir THEN
  temp=DIR$ (Cudi,18 TO CurFold)
  oldfoldtime=CurFold.LastWriteTime
  listu:
  IF oldu<>cudi OR oldfoldtime=CurFold.LastWriteTime THEN GOSUB limpa
  GRAPHIC COLOR corfile(w(fileposi)),ftop
  GRAPHIC SET POS (25,90)
  GRAPHIC PRINT Listing(fileposi).FileName;SPACE$(400)
  oldname=Listing(fileposi).FileName

  IF mfp=>3707 AND oldir<>"" THEN GOSUB limpa

  IF mfp>0 AND mfp<3709 THEN
   FOR uu=0 TO 1
    pap=0
    FOR ii=0 TO 350 STEP 10
     FOR i=0 TO 1020 STEP 10
      GRAPHIC BOX (25+i,120+ii)-(34+i,129+ii),,corfile(w(pap))
      INCR pap
      IF pap=mfp THEN vgh
     NEXT
    NEXT
   NEXT
   vgh:
   oldfileposi=-1
   lb=0
  END IF


  oldir=Cudi
  oldu=cudi

  RESET mensagem()
  mensagem(0)=Cudi
  IF ndirs>0 THEN
    mensagem(1)=LTRIM$(FORMAT$(ndirs,"######"),ANY " ")+" folder"
    IF ndirs>1 THEN mensagem(1)=mensagem(1)+"s " ELSE mensagem(1)=mensagem(1)+" "
  END IF

  IF mfp-ndirs>0 THEN
    mensagem(1)=mensagem(1)+LTRIM$(FORMAT$(mfp-ndirs,"######"), ANY " ")+" file"
    IF mfp-ndirs>1 THEN mensagem(1)=mensagem(1)+"s " ELSE mensagem(1)=mensagem(1)+" "
  END IF
   mensagem(3)=mensagem(1)
   IF crypt>0 THEN mensagem(1)=mensagem(1)+ LTRIM$(FORMAT$(crypt,"###"),ANY " ")+" encrypted"
   GOSUB escremen
  END IF


DO

  temp=DIR$ (Cudi,18 TO CurFold)
  IF CurFold.lastWriteTime <> oldfoldtime THEN
    mfpold=mfp
   oldfoldtime=CurFold.LastWriteTime
   cont=0
   fola=listing(fileposi).LastAccessTime
   GOSUB findfiles

  IF mfp<mfpold THEN
   IF fileposi=mfpold-1 THEN
   IF fileposi>0 THEN DECR fileposi
   GRAPHIC BOX (25+(oldfileposi MOD 103)*10 ,120+(oldfileposi\103)*10)-(34+(oldfileposi MOD 103)*10,129+(oldfileposi\103)*10),,fbot
   GRAPHIC BOX (27+(fileposi MOD 103)*10,122+(fileposi\103)*10)-(32+(fileposi MOD 103)*10,127+(fileposi\103)*10),,corfile(w(fileposi))
   GOTO listar
  END IF
END IF

  FOR i=0 TO mfp-1
   IF fola=listing(i).LastAccessTime THEN
    fileposi=i
    GOTO listu
   END IF
  NEXT

   IF mfp=1 AND mfpold=0 THEN fileposi=0:GOTO lista
   IF mfp=0 THEN vazio
   IF w(fileposi)<>w(oldfileposi) THEN GOSUB filetype
   oldir=""
   GOTO lista
  END IF

 IF  fileposi<>oldfileposi AND lb=0 THEN
  listar:
  IF showed<>"lista" THEN showed="lista":GOTO listu
  IF mfp>0 AND mfp<3709 THEN
   GRAPHIC BOX (27+(oldfileposi MOD 103)*10 ,122+(oldfileposi\103)*10)-(32+(oldfileposi MOD 103)*10,127+(oldfileposi\103)*10),,fbot
   GRAPHIC BOX (27+(fileposi MOD 103)*10,122+(fileposi\103)*10)-(32+(fileposi MOD 103)*10,127+(fileposi\103)*10),,corfile(w(fileposi))

  END IF
   oldfileposi=fileposi
 END IF

IF lb=1 THEN
  IF mfp<3709 AND mousepoint.y=>120 AND mousepoint.y<=129+(mfp\103)*10 AND mousepoint.x=>25 AND mousepoint.x<=MIN(25+mfp*10,xsize-25) THEN
   fileposi=MIN(((mousepoint.x-25)\10)+((mousepoint.y-120)\10)*103,mfp-1)
   lb=0
   IF fileposi=oldfileposi THEN
    IF w(fileposi)=2 THEN enter
    IF w(fileposi)<2 THEN chabi
   END IF
   GOTO listar
  END IF

 IF mousepoint.y=>90 AND mousepoint.y<=90+altura THEN
  IF mousepoint.x>=25 AND mousepoint.x<=GRAPHIC(TEXT.SIZE.X, Listing(fileposi).filename)+25 THEN
   IF w(fileposi)=2 THEN enter
   IF w(fileposi)<2 THEN chabi
  END IF
 END IF
END IF

 wpl:
  GRAPHIC INKEY$ TO lt

 IF fileposi<>fileold AND lb=0 THEN
  fileold=fileposi
  GRAPHIC COLOR corfile(w(fileposi)),fbot
  GRAPHIC SET POS (25,90)
  GRAPHIC PRINT Listing(fileposi).FileName;SPACE$(350)
 END IF

 IF fileposi<>oldfileposi OR oldcat<>w(fileposi) THEN
  cat=w(fileposi)
  oldfileposi=fileposi
  IF oldcat<>cat OR oldfileposi*fileposi=0 THEN
    GOSUB filetype
    oldcat=cat
  END IF
  sizeold=MAK(QUAD,Listing(fileposi).FileSizeLow,Listing(fileposi).FileSizeHigh)
 END IF

 sdf:

 IF hVin=0 THEN Exitprog

IF LEN(lt)=2 AND RIGHT$(lt,1)="S" THEN GOSUB lixo

 GetCursorPos Mousepoint
 ScreenToClient hWin, MousePoint
 nonov:
 SLEEP 1

 IF mousepoint.y<0 OR mousepoint.y>63 THEN GRAPHIC LINE (px1old,52)-(px2old,52),ftop1:px1old=-1
 IF mousepoint.x<28 OR mousepoint.x>497 THEN
   FOR i=px1old TO px2old
    GRAPHIC SET PIXEL (i,52), ftop1
   NEXT
   px1old=0
   SLEEP 10
   mold=mousepoint.x*mousepoint.y
   IF lb=%WM_NCLBUTTONDOWN AND mousepoint.x>497 THEN listado
 END IF
 IF mousepoint.y>0 AND mousepoint.y<56 THEN

   IF lb=1 AND showed="lista" AND mousepoint.x=>28 AND mousepoint.x<=68 THEN lb=0
   IF lb=1 THEN lb=0:GOSUB MOUSEPRESSED :lb=0


   px1=px1old
  IF mousepoint.x=>28  AND  mousepoint.x<=68 THEN px1=28:px2=68:showed="lista"
  IF mousepoint.x=>69  AND mousepoint.x<=110 THEN px1=69:px2=110
  IF mousepoint.x=>111 AND mousepoint.x<=151 THEN px1=111:px2=151
  IF mousepoint.x=>152 AND mousepoint.x<=199 THEN px1=152:px2=199
  IF mousepoint.x=>200 AND mousepoint.x<=242 THEN px1=200:px2=242
  IF mousepoint.x=>243 AND mousepoint.x<=288 THEN px1=243:px2=288
  IF mousepoint.x=>289 AND mousepoint.x<=334 THEN px1=289:px2=334
  IF mousepoint.x=>335 AND mousepoint.x<=376 THEN px1=335:px2=377
  IF mousepoint.x=>377 AND mousepoint.x<=419 THEN px1=377:px2=419
  IF mousepoint.x=>420 AND mousepoint.x<=458 THEN px1=418:px2=456
  IF mousepoint.x=>457 AND mousepoint.x<=497 THEN px1=457:px2=497

   IF  px1<>px1old THEN
    GRAPHIC LINE (px1old,52)-(px2old,52),ftop1
    GRAPHIC LINE (px1,52)-(px2,52),fbot
    px1old=px1:px2old=px2
   END IF
 END IF

 listado:

 IF lt=$BS AND LEN(cudi)=3 THEN lt=""
LOOP UNTIL lt<>"" AND lt<>lyp

lb=0

IF GetAsyncKeyState(%vk_F1) THEN showed="Ajuda":GOTO ajuda
IF GetAsyncKeyState(%vk_F2) THEN proc=2:GOSUB encontra
IF GetAsyncKeyState(%vk_F3) THEN proc=0:GOSUB encontra
IF GetAsyncKeyState(%vk_F4) THEN proc=1:GOSUB encontra
IF GetAsyncKeyState(%vk_ESCAPE) THEN escapar

IF LEN(lt)=2 THEN ly=RIGHT$(lt,1)
IF ASC(lt)>31 AND ASC(lt)<127 THEN proc=3:GOSUB encontra


lyp=ly

 IF lt=$BS AND LEN(cudi)>3 THEN k=lt:lt="":GOTO nodo1
 IF ly="H" THEN fileposi-=103:IF fileposi<0 THEN fileposi=oldfileposi
 IF ly="P" THEN fileposi+=103:IF fileposi=>mfp THEN fileposi=oldfileposi
 IF ly="K" THEN fileposi-=1
 IF ly="M" THEN fileposi+=1
 IF ly="G" THEN fileposi=0
 IF ly="O" THEN fileposi=mfp-1
 IF fileposi>mfp-1 THEN fileposi=mfp-1
 IF fileposi<0 THEN fileposi=0
 IF lt=$CR AND mfp>0 AND w(fileposi)<2 THEN chabi

 IF lt=$CR AND w(fileposi)=2 THEN
  enter:
  IF mensagem(1)="Empty folder" THEN nodo1
  cat=w(fileposi)
  mensagem(1)="Please wait."
  cont=0
  lt=""
  posdir(ded)=fileposi

  cudi=CURDIR$+"\"+Listing(fileposi).FileName
  CHDIR Listing(fileposi).filename
  nret =  gcd (2048,Cudi)
  GOSUB findfiles

  IF cudi=oldir THEN
   mensagem(0)=cudi+listing(fileposi).FileName
   mensagem(1)="Folder with inaccessible content"
   GOSUB limpa
   GOSUB escremen
   oldfileposi=fileposi
   mfp=0
   GOSUB filetype
   GOTO espera
  END IF

 mfpold=0
 IF LCASE$(cudi)=LCASE$(oldir) THEN lista
 IF mfp=0 THEN lista

  FOR ded=0 TO 1000
   IF cudi=cam(ded) OR cam(ded)="" THEN EXIT FOR
  NEXT
  fileposi=posdir(ded)
  cam(ded)=cudi

 GOSUB escremen
END IF

lt="":ly=""
oldir=Cudi
lb=0

 IF fileposi=fileold THEN wpl
 IF mfp>3709 THEN listu

 IF cudi=oldu THEN GOTO listar

 IF cudi<>oldu THEN GOTO lista

RETURN

REM ----------------------------------------------------------------------------------------------------------------
CRYPTA:

GRAPHIC WINDOW STABILIZE
GOSUB verfile
contbit1=0

mensagem(0)=""
GOSUB escremen
GRAPHIC COLOR rodacor,fbot


IF LOF(1)<65520 THEN voa

FOR i=0 TO tss\blksize

 GET$ 1,blksize,block
 blkk=LEN(block)

 IF tss\blksize-i>0 THEN
  GRAPHIC SET POS (25,ysize-3*altura+21)
  GRAPHIC PRINT FORMAT$(i/(tss/blksize)*100,"##,##")+"%"
 END IF

 IF hVin=0 THEN Exitprog

 FOR p=STRPTR(block) TO STRPTR(block)+blkk-21 STEP 21
  x(a)=x(b) + x(c)
  BIT RESET x(a),62
  a+=b+i
  POKE QUAD,p,PEEK(QUAD,p)       XOR ( x(a) + x(b) )
  c+=a
  POKE QUAD,p+7,PEEK(QUAD,p+7)   XOR ( x(c) + x(a) )
  b+=c
  POKE QUAD,p+14,PEEK(QUAD,p+14) XOR ( x(b) + x(c) )
 NEXT

 SEEK 1,i*blksize
 PUT$ 1, block

NEXT

 SEEK 1,sizeold-blkk
 GET$ 1,blkk,block
 blkk=LEN(block)
 SEEK 1,(i-1)*blksize
 GOTO voa2

 voa:
 GET$ 1,blksize,block
 blkk=LEN(block)
 SEEK 1,0
 voa2:
 FOR p=STRPTR(block) TO STRPTR(block)+blkk
  x(a)=x(b) + x(c)
  BIT RESET x(a),62
  a+=b+i
  c+=a
  b+=c
  POKE p,PEEK(p) XOR ( x(a) + x(b) )
 NEXT
 PUT$ 1, block
 CLOSE 1

 w(fileposi)=1-w(fileposi)
 IF w(fileposi)=1 THEN INCR crypt ELSE DECR crypt

 IF w(fileposi)=1 THEN NAME Listing(fileposi).filename AS Listing(fileposi).filename+nome
 IF w(fileposi)=0 THEN NAME Listing(fileposi).filename AS LEFT$(Listing(fileposi).filename,LEN(Listing(fileposi).filename)-nm)

RESET x():contbit1=0:a=0:b=0:c=0

oldcat=3

GOSUB caixa

GRAPHIC WINDOW NONSTABLE

GRAPHIC COLOR fuc,fbot
cont=-2
GOSUB findfiles
GOSUB filetype

  mensagem(0)=""
  mensagem(1)=cap
  GOSUB escremen
   integral=0
GOTO chave


REM ------------------------------------------------------------------------------------------------------------------
VERFILE:

 IF mfp=0 THEN
  GOSUB limpa
  cont=0
  mensagem(0)=cudi
  mensagem(1)="Empty folder"
  GOSUB escremen
  nret =  gcd (2048,cudi)
  oldir=cudi
  GOTO listar
 END IF

OPEN Listing(fileposi).filename FOR BINARY AS 1 BASE =0
sizeold=MAK(QUAD,Listing(fileposi).FileSizeLow,Listing(fileposi).FileSizeHigh)
IF FILEATTR(1,0)=0 THEN men="File already open":CLOSE:GOTO ERRO
blksize=IIF(sizeold<=65520,sizeold,65520)
tss=INT(blksize*sizeold/blksize)-1
RETURN

REM ----------------------------------------------------------------------------------------------------------------
ERRO:
 GOSUB printerro
 RESET x():contbit1=0
 GOTO NODO1

REM ----------------------------------------------------------------------------------------------------------------
ESPERA:

DO

IF GetAsyncKeyState(%vk_F1) AND showed<>"ajuda" THEN showed="ajuda":GOTO ajuda
 IF mfp=0 THEN
 temp=DIR$ (Cudi,18 TO CurFold)
  IF CurFold.lastWritetime <> oldfoldtime THEN
   oldfoldtime=CurFold.LastWriteTime
   cont=0
   GOSUB findfiles
   IF mfp=1 AND mfpold=0 THEN pap=1:piu=0:GOTO lista
  END IF
 END IF


 px1=0
 parado:
 SLEEP 6
 mold=mousepoint.x*mousepoint.y
 GetCursorPos Mousepoint
 ScreenToClient hWin, MousePoint

  GRAPHIC INKEY$ TO k
  IF lb=0 AND k="" AND ( mousepoint.x<28 OR mousepoint.x>494 OR mousepoint.y<0 OR mousepoint.y>62) THEN
   IF linclar=0 THEN GRAPHIC LINE (px1old,52)-(px2old,52),ftop1:linclar=1
   GOTO parado
  END IF
  linclar=0

 IF mousepoint.y>=0 AND mousepoint.y<56 AND mousepoint.x=>28 AND mousepoint.x<=494 THEN
  px1=0
  IF mousepoint.x=>28  AND  mousepoint.x<=68 THEN px1=28:px2=68
  IF mousepoint.x=>69  AND mousepoint.x<=110 THEN px1=69:px2=110
  IF mousepoint.x=>111 AND mousepoint.x<=151 THEN px1=111:px2=151
  IF mousepoint.x=>152 AND mousepoint.x<=199 THEN px1=152:px2=199
  IF mousepoint.x=>200 AND mousepoint.x<=242 THEN px1=200:px2=243
  IF mousepoint.x=>243 AND mousepoint.x<=288 THEN px1=243:px2=288
  IF mousepoint.x=>289 AND mousepoint.x<=334 THEN px1=289:px2=332
  IF mousepoint.x=>335 AND mousepoint.x<=376 THEN px1=335:px2=377
  IF mousepoint.x=>377 AND mousepoint.x<=419 THEN px1=377:px2=419
  IF mousepoint.x=>420 AND mousepoint.x<=458 THEN px1=418:px2=456
  IF mousepoint.x=>457 AND mousepoint.x<=497 THEN px1=457:px2=497

   IF  px1<>0 AND mold<>mousepoint.y*mousepoint.x THEN
    GRAPHIC LINE (px1old,52)-(px2old,52),ftop1
    GRAPHIC LINE (px1,52)-(px2,52),fbot
    px1old=px1:px2old=px2
    mold=mousepoint.y*mousepoint.x
   END IF
 END IF

 IF lb=1 THEN  lb=0:GOSUB MOUSEPRESSED :SLEEP 6
 IF hVin=0 THEN Exitprog

LOOP UNTIL k<>""
 IF k=$BS THEN nodo1
 IF k=$ESC THEN escapar
 GOTO espera

RETURN

REM --------------------------------------------------------------------------------------------------------------
MOUSEPRESSED:

 IF mousepoint.y>=9 AND mousepoint.y<56 AND mousepoint.x=>457 AND mousepoint.x<=497 AND k="" THEN
   RESET x():contbit1=0
   hVin=0
   GOTO Exitprog
 END IF

 IF LEN(Cudi)>3 THEN oldir=""

 CLOSE
 GRAPHIC COLOR fuc,ftop

IF mousepoint.y=>0 AND mousepoint.y<56 THEN

 IF mousepoint.x<=27 THEN
  escapar:
  oldir=""
  CLOSE
  mostra:
  GOSUB makemenu
  showed="vazio"
  SetRect rc, 0, 58, xsize+4, ysize +4
  hHoleRgn = CreateRectRgn(rc.nLeft, rc.nTop, rc.nRight, rc.nBottom)
  CreateHole(hWin, hHoleRgn)
  GOTO espera
 END IF

 IF mousepoint.x=>28 AND mousepoint.x<=68 AND LEN(Cudi)=>3  THEN
  IF mensagem(1)="Folder with inaccessible content" THEN
   IF showed="lista" THEN espera
   IF showed="vazio" THEN GOSUB limpa:GOTO lista
  END IF
  oldir=""
  GOTO lista
 END IF

 IF mousepoint.x=>69 AND mousepoint.x<=110 AND LEN(cudi)=>3 THEN
  k=$BS
  GOTO nodo1
 END IF

  IF mousepoint.x=>111 AND mousepoint.x<=151 AND w(fileposi)=2 AND showed<>"lista" THEN GOSUB limpa:showed="lista":GOTO lista
  IF mousepoint.x=>111 AND mousepoint.x<=151 AND w(fileposi)<2 THEN
   GOSUB VERFILE
   GOSUB chabi
  END IF

 IF mousepoint.x=>152 AND mousepoint.x<=199 AND w(fileposi)=2 AND showed<>"lista" AND crypt=0 THEN GOSUB limpa:showed="lista":GOTO lista
 IF mousepoint.x=>152 AND mousepoint.x<=199 AND crypt>0 THEN
  IF showed="lista" AND crypt=1 AND w(fileposi)=1 THEN vnm
  IF showed<>"lista" THEN GOSUB limpa
  IF crypt>0 THEN proc=1:GOTO encontra
  vnm:
 END IF

 IF mousepoint.x=>200 AND mousepoint.x<=242 AND w(fileposi)=2 AND showed<>"lista" THEN GOSUB limpa:showed="lista":GOTO lista
 IF mousepoint.x=>200 AND mousepoint.x<=242 AND w(fileposi)<2 THEN
  IF showed<>"statistics" THEN GOSUB Statistics
 END IF

 IF mousepoint.x=>243 AND mousepoint.x<=288 AND showed<>"floats" THEN GOSUB floats

 IF mousepoint.x=>289 AND mousepoint.x<=334 THEN
  IF mfp=0 THEN RETURN
     showed="lista"
     GOSUB limpa
    oldir=cudi
    IF mensagem(1)="Folder with inaccessible content" THEN RETURN
   IF w(fileposi)=2 THEN enter
   GOTO Ler
 END IF

 IF mousepoint.x=>335 AND mousepoint.x<=376 AND k="" THEN lb=0:GRAPHIC WINDOW MINIMIZE

 IF mousepoint.x=>377 AND mousepoint.x<=419 AND k="" AND showed<>"ajuda" THEN
  Ajuda:
  oldir=""
  RESET mensagem()
  GOSUB escremen
  GOSUB limpa

  FONT NEW tipo,30,0,0,0,0 TO fhndl
  GRAPHIC SET FONT fhndl
  GRAPHIC COLOR fbot+1,fbot
  GRAPHIC SET POS (50,80)
  GRAPHIC PRINT "Melgo"

  FOR i=62 TO 80
   GRAPHIC GET PIXEL (50,i)TO cori
   IF cori=fbot+1 THEN EXIT FOR
  NEXT

  GRAPHIC COLOR fuc,fbot
  GRAPHIC SET POS (50,i)
  GRAPHIC PRINT "Melgo"

  GRAPHIC COLOR %RGB_DARKGRAY,-2
  GRAPHIC SET POS (48,i-3)
  GRAPHIC PRINT "Melgo"

  GRAPHIC COLOR fuc,fbot
  FONT NEW tipo,8,0,0,0,0 TO fhndl
  GRAPHIC SET FONT fhndl

  GRAPHIC BOX (0,ysize-50)-(xsize,ysize),,fbot,fbot
  FOR i=0 TO 22
   GRAPHIC SET POS (50,10+(6+i)*23*.8)
   IF i>3 AND i<18 THEN
    GRAPHIC SET POS (70,10+(6+i)*23*.8)
    GRAPHIC PRINT Aju(i)
   ELSE
    GRAPHIC SET POS (50,10+(6+i)*23*.8)
    IF i=19 THEN
     GRAPHIC SET POS (50,10+(6+i)*23*.8)
     GRAPHIC COLOR fuc,fbot
     GRAPHIC PRINT "Warning:"

     GRAPHIC SET POS (49,9+(6+i)*23*.8)
     GRAPHIC COLOR %RGB_DARKGRAY,-2
     GRAPHIC PRINT "Warning:"

     GRAPHIC SET POS (95,10+(6+i)*23*.8)
     GRAPHIC COLOR fuc,fbot
    END IF
     GRAPHIC PRINT Aju(i)
   END IF
  NEXT
  showed="ajuda"
  GOTO nodo
 END IF

 IF mousepoint.x=>418 AND mousepoint.x<=458 AND w(fileposi)=2 AND showed<>"lista" THEN GOSUB limpa:showed="lista":GOTO lista
 IF mousepoint.x=>418 AND mousepoint.x<=458 AND w(fileposi)<2 THEN
  IF showed<>"lixo" THEN GOSUB lixo
 END IF

 IF w(fileposi)=2 THEN mousepoint.x=0

RETURN


REM Select the seed bits ---------------------------------------------------------------------
CHABI:

GOSUB limpa

  nbit=0
GRAPHIC INKEY$ TO k

ud=28
ux=-70
showed="chabi"

FONT NEW tipo,28,0,0,0,0 TO fhndl
GRAPHIC SET FONT fhndl

xlarg=GRAPHIC(TEXT.SIZE.X,"0")
yalt=GRAPHIC(TEXT.SIZE.Y,"0")

  xat=GRAPHIC(TEXT.SIZE.X,"0")
  yat=GRAPHIC(TEXT.SIZE.Y,"0")
  FOR i=0 TO yat
   FOR u=0 TO xat
    GRAPHIC GET PIXEL (u,i) TO corp
    IF corp=%RGB_DARKGRAY  THEN yat1=i
    GRAPHIC GET PIXEL (u,yat-i) TO corp
    IF corp=%RGB_DARKGRAY  THEN yat2=i
   NEXT
  NEXT
  yat=160+(84-yat-yat1-yat2)/2


 FOR u=-1 TO 1
   FOR i=0 TO 7
     IF u=-1 AND i=1 THEN
      GRAPHIC BOX (185,160)-(359,244),,ftop1,%RGB_DARKGRAY
      i=3

      GRAPHIC COLOR %RGB_LIGHTGRAY,%RGB_DARKGRAY
      GRAPHIC SET POS (346+1-GRAPHIC(TEXT.SIZE.X,"0"),yat+1)
      GRAPHIC PRINT "0"

      GRAPHIC COLOR corkey(0),-2
      GRAPHIC SET POS (346-GRAPHIC(TEXT.SIZE.X,"0"),yat)
      GRAPHIC PRINT "0"
     END IF
     GRAPHIC BOX (95+i*90,250+u*90)-(179+i*90,334+u*90),,%RGB_DIMGRAY,%RGB_DIMGRAY
 NEXT
NEXT

GRAPHIC COLOR fbot,%RGB_DIMGRAY

 RANDOMIZE TIMER
 scha = "0123456789"
 REDIM sh( 1 TO 10 ) AS BYTE AT STRPTR(scha)
 FOR i = 1 TO 9
  SWAP sh(i), sh(RND(i,10))
 NEXT

GRAPHIC COLOR fbot,%RGB_DIMGRAY
FONT NEW tipo,16,0,0,0,0 TO fhndl
GRAPHIC SET FONT fhndl
t1=GRAPHIC(TEXT.SIZE.Y, "1")

uu=-1

FOR u=0 TO 1
 FOR i=0 TO 4
  GRAPHIC SET POS (92+(90-GRAPHIC(TEXT.SIZE.X, "1")  )\2+i*90,247+(90-t1)\2+u*90)
  GRAPHIC PRINT MID$(scha,(i+5*u)+1,1)
 NEXT
NEXT

GRAPHIC COLOR fbot,%RGB_DIMGRAY
FONT NEW tipo,12,0,0,0,0 TO fhndl
GRAPHIC SET FONT fhndl
t1=GRAPHIC(TEXT.SIZE.Y, tn(0))
uu=-1


FOR u=-1 TO 1
 FOR i=5 TO 7
  INCR uu
  an(uu)=GRAPHIC(TEXT.SIZE.X, tn(uu))
  GRAPHIC SET POS (45+(90-an(uu)\2)+i*90,245+(90-t1)\2+u*88+1)
  GRAPHIC PRINT tn(uu)
 NEXT
NEXT

  tn(11)=cryval(w(fileposi))
  an(11)=GRAPHIC(TEXT.SIZE.X, tn(11))
  GRAPHIC SET POS (45+(90-an(11)\2),245+(90-t1)\2-89)
  GRAPHIC PRINT tn(11)

  an(9)=GRAPHIC(TEXT.SIZE.X, tn(9))
  GRAPHIC SET POS (45+(90-an(9)\2)+3*90,245+(90-t1)\2-89)
  GRAPHIC PRINT tn(9)

  an(10)=GRAPHIC(TEXT.SIZE.X, tn(10))
  GRAPHIC SET POS (45+(90-an(10)\2)+4*90,245+(90-t1)\2-89)
  GRAPHIC PRINT tn(10)

chave:
FONT NEW tipo,8,0,0,0,0 TO fhndl
GRAPHIC SET FONT fhndl
GRAPHIC COLOR %RGB_DIMGRAY

 GRAPHIC COLOR corfile(w(fileposi)),ftop
 GRAPHIC SET POS (25,90)
 GRAPHIC PRINT Listing(fileposi).filename+SPACE$(200)
 GRAPHIC COLOR fuc

 mensagem(1)=valor(w(fileposi))+" "+LTRIM$(FORMAT$(sizeold,"## ### ### ###"))+" bytes"
 mensagem(0)=""
 GOSUB escremen
 oldfile=""


a=0
b=0
c=0
nbit=0
nbitold=2
contbit1=0
contbit1old=1
ud=28
RESET x()
ux=-70
corcai=fuc


GRAPHIC COLOR rodacor,fbot
GRAPHIC SET POS (25,ysize-2.3*altura)
GRAPHIC PRINT SPACE$(50)


DO
    IF GetAsyncKeyState(%vk_F1) THEN showed="Ajuda":GOTO ajuda
 ert:
 IF contbit1old<>contbit1 THEN contbit1old=contbit1
 IF lb=1 AND mousepoint.x=>111 AND mousepoint.x<=151 AND mousepoint.y=>0 AND mousepoint.y<56 THEN lb=0

  ist=0
  iold=0

GOSUB verfile
 sizeold=LOF(1)

 IF lb=1 THEN  lb=0:SLEEP 3:GOSUB MOUSEPRESSED

 IF hVin=0 THEN Exitprog
 IF k="" THEN SLEEP 20 ELSE SLEEP 6
  mold=mousepoint.x*mousepoint.y
 GetCursorPos Mousepoint
 ScreenToClient hWin, MousePoint


 IF  mousepoint.x<28 OR mousepoint.x>494 THEN GRAPHIC LINE (px1old,52)-(px2old,52),ftop1 :mold=mousepoint.x*mousepoint.y
 IF mousepoint.y=>0 AND mousepoint.y<56 THEN
  px1=0
  IF mousepoint.x=>28  AND  mousepoint.x<=68 THEN px1=28:px2=68
  IF mousepoint.x=>69  AND mousepoint.x<=110 THEN px1=69:px2=110
  IF mousepoint.x=>111 AND mousepoint.x<=151 THEN px1=111:px2=151
  IF mousepoint.x=>152 AND mousepoint.x<=199 THEN px1=152:px2=199
  IF mousepoint.x=>200 AND mousepoint.x<=242 THEN px1=200:px2=242
  IF mousepoint.x=>243 AND mousepoint.x<=288 THEN px1=243:px2=288
  IF mousepoint.x=>289 AND mousepoint.x<=334 THEN px1=289:px2=334
  IF mousepoint.x=>335 AND mousepoint.x<=376 THEN px1=335:px2=377
  IF mousepoint.x=>377 AND mousepoint.x<=419 THEN px1=377:px2=419
  IF mousepoint.x=>420 AND mousepoint.x<=458 THEN px1=418:px2=456
  IF mousepoint.x=>457 AND mousepoint.x<=497 THEN px1=457:px2=497
  IF  px1<>0 AND mousepoint.x<>px1old THEN
    GRAPHIC LINE (px1old,52)-(px2old,52),ftop1
    GRAPHIC LINE (px1,52)-(px2,52),fbot
    px1old=px1:px2old=px2
  END IF

 END IF

 IF px1=0 OR mousepoint.y<0 OR mousepoint.y=>56 THEN GRAPHIC LINE (px1old,52)-(px2old,52),ftop1

  IF k=$CR OR lb=1 AND mousepoint.x>95+90 AND mousepoint.x<448-90 AND mousepoint.y>161 AND mousepoint.y<243 THEN
   mold=0
    BIT TOGGLE x(nbit\56),nbit MOD 56
    bti=BIT(x((nbit)\56),nbit MOD 56)
    contbit1+=2*bti-1
    b+=(2*bti-1)*nbit
    lb=0
  END IF


IF lb=1 THEN
  FOR u=0 TO 1
   FOR i=0 TO 4
     IF mousepoint.x>95+i*90 AND mousepoint.x<179+i*90 AND mousepoint.y>250+u*90  AND mousepoint.y<334+u*90 THEN
     GRAPHIC BOX (95+i*90,250+u*90)-(179+i*90,334+u*90),,ftop1
      utu=0
      DO
       GetCursorPos Mousepoint
       ScreenToClient hWin, MousePoint
       IF mousepoint.x<95+i*90 OR mousepoint.x>179+i*90 OR mousepoint.y<250+u*90  OR mousepoint.y>334+u*90 THEN lb=0:utu=-1
      LOOP UNTIL lb=0
     GRAPHIC BOX (95+i*90,250+u*90)-(179+i*90,334+u*90),,%RGB_DIMGRAY
     IF utu=-1 THEN ert
     k=MID$(scha,(i+5*u)+1,1)
      GOTO nonu
    END IF
   NEXT
  NEXT

 IF mousepoint.x>95 AND mousepoint.x<180 AND mousepoint.y>161 AND mousepoint.y<244 THEN

   GRAPHIC BOX (95,160)-(179,244),,ftop1
      utu=0
      DO
       GetCursorPos Mousepoint
       ScreenToClient hWin, MousePoint
       IF mousepoint.x<95 OR mousepoint.x>180 OR mousepoint.y<161  OR mousepoint.y>244 THEN lb=0:utu=-1
      LOOP UNTIL lb=0

  GRAPHIC BOX (95,160)-(179,244),,%RGB_DIMGRAY

  IF utu=-1 THEN ert
  IF contbit1>0 THEN

  REM Generate the seeds for x(0) to x(2^16-1)###################################################
   nm=0
   IF w(fileposi)=0 THEN
    nm=16*FRAC(TIMER)+1
    nome=""
    FOR i=1 TO nm
     nome=nome+CHR$$(8203)
    NEXT
   END IF

   IF w(fileposi)=1 THEN
    FOR i=LEN(Listing(fileposi).filename) TO 1 STEP-1
     IF MID$(Listing(fileposi).filename,i,1)=CHR$$(8203) THEN INCR nm
    NEXT
   END IF
   c=nm
   FOR i=0 TO n
    a+=b+1
    c+=a+1
    b+=c+1
    x(i)=(x(i)+a*b*c*i+i) MOD m
   NEXT
  REM ###########################################################################################
   GOTO CRYPTA
  END IF

  IF contbit1=0 THEN
   oldmen=mensagem(0)
   mensagem(0)="Empty key"
   GOSUB escremen
   SLEEP 1000
   mensagem(0)=oldmen
   GOSUB escremen
  END IF
 END IF


uu=-1
FOR u=-1 TO 1
 FOR i=5 TO 7
  INCR uu
    IF mousepoint.x>95+i*90 AND mousepoint.x<179+i*90 AND mousepoint.y>250+u*90  AND mousepoint.y<334+u*90 THEN
     GRAPHIC BOX (95+i*90,250+u*90)-(179+i*90,334+u*90),,ftop1
     utu=0
     DO
       GetCursorPos Mousepoint
       ScreenToClient hWin, MousePoint
       IF mousepoint.x<95+i*90 OR mousepoint.x>179+i*90 OR mousepoint.y<250+u*90  OR mousepoint.y>334+u*90 THEN lb=0:utu=-1
     LOOP UNTIL lb=0
     GRAPHIC BOX (95+i*90,250+u*90)-(179+i*90,334+u*90),,%RGB_DIMGRAY
     IF utu=-1 THEN ert
     lb=0
     k=vk(uu)
     GOTO nonu
    END IF
 NEXT
NEXT

 IF mousepoint.x>95+3*90 AND mousepoint.x<179+3*90 AND mousepoint.y>160  AND mousepoint.y<244 THEN

     GRAPHIC BOX (95+3*90,160)-(179+3*90,244),,ftop1
      utu=0
      DO
       GetCursorPos Mousepoint
       ScreenToClient hWin, MousePoint
       IF mousepoint.x<95+3*90 OR mousepoint.x>179+3*90 OR mousepoint.y<160  OR mousepoint.y>244 THEN lb=0:utu=-1
      LOOP UNTIL lb=0
     GRAPHIC BOX (95+3*90,160)-(179+3*90,244),,%RGB_DIMGRAY
     IF utu=-1 THEN ert
     lb=0
     nbit=RND(0,3670015)
     GRAPHIC BOX (186,161)-(358,243),,%RGB_DARKGRAY,%RGB_DARKGRAY
     GOTO nonu
 END IF


 IF mousepoint.x>95+4*90 AND mousepoint.x<179+4*90 AND mousepoint.y>160  AND mousepoint.y<244 THEN

   GRAPHIC BOX (95+4*90,160)-(179+4*90,244),,ftop1
       utu=0
       DO
       GetCursorPos Mousepoint
       ScreenToClient hWin, MousePoint
       IF mousepoint.x<95+4*90 OR mousepoint.x>179+4*90 OR mousepoint.y<160  OR mousepoint.y>244 THEN lb=0:utu=-1
      LOOP UNTIL lb=0
    GRAPHIC BOX (95+4*90,160)-(179+4*90,244),,%RGB_DIMGRAY
   IF utu=-1 THEN ert
   lb=0
  GRAPHIC BOX (185,160)-(359,244),,%RGB_LIGHTGRAY,%RGB_DARKGRAY
  IF tn(10)="Hide" THEN tn(10)="Show" ELSE tn(10)="Hide"

   FONT NEW tipo,12,0,0,0,0 TO fhndl
   GRAPHIC SET FONT fhndl
   GRAPHIC COLOR fbot,%RGB_DIMGRAY

   GRAPHIC SET POS (40+(90-GRAPHIC(TEXT.SIZE.X, tn(10)) \2)+4*90,245+(90-t1)\2-89)
   GRAPHIC PRINT SPACE$(11)


   GRAPHIC SET POS (45+(90-GRAPHIC(TEXT.SIZE.X, tn(10)) \2)+4*90,245+(90-t1)\2-89)
   GRAPHIC PRINT tn(10)

  FONT NEW tipo,8,0,0,0,0 TO fhndl
   GRAPHIC SET FONT fhndl

   IF tn(10)="Hide" THEN acx
   IF tn(10)="Show" THEN GRAPHIC BOX (185,160)-(359,244),,%RGB_LIGHTGRAY,%RGB_DARKGRAY
 END IF


 END IF

 GRAPHIC INKEY$ TO k
 IF k=$BS AND nbit=0 THEN k=""
 nonu:
 ky=RIGHT$(k,1)
 IF k=$ESC THEN escapar

salpico:

IF k=$BS THEN nbit=VAL(LEFT$(STR$(nbit),LEN(STR$(nbit))-1))
IF ASC(k)>47 AND ASC(k)<58 AND LEN(STR$(nbit))<8 AND VAL(STR$(nbit)+k)<3670016 THEN  nbit=VAL(STR$(nbit)+k)

IF LEN(k)=2 OR k=" " THEN
 IF ky="P"  THEN nbit-=1
 IF ky="H"  THEN nbit+=1
 IF ky="G" AND nbit>0 THEN nbit=0
 IF ky="O" THEN nbit=3670015
 IF ky="I" THEN nbit+=pg
 IF ky="Q" THEN nbit-=pg
 IF nbit>3670015  THEN nbit=0
 IF nbit<0 THEN nbit=3670015
 IF ky="S" THEN eras

IF contbit1>0 THEN
 eras:
 IF ky="S" THEN
  RESET x()
  nbit=0
  nbitold=2
  a=0:b=0:c=0:contbit1=0:contbit1old=2
  GOTO adx
 END IF

 IF ky=" " AND contbit1>0 THEN
   DO
    INCR nbit
    IF nbit>3670015  THEN nbit=0
    IF BIT(x(nbit\56),nbit MOD 56)=1 THEN
     GRAPHIC BOX (186,161)-(358,243),,%RGB_DARKGRAY,%RGB_DARKGRAY
     nbitold=-1
     EXIT
    END IF
   LOOP
  END IF

 END IF
END IF

 IF contbit1<>contbit1old THEN
  adx:
  FONT NEW tipo,8,0,0,0,0 TO fhndl
  GRAPHIC SET FONT fhndl
  GRAPHIC COLOR rodacor,fbot
  GRAPHIC SET POS (25,ysize-2.3*altura+5)
  IF contbit1>0 THEN GRAPHIC PRINT "Bits on:";contbit1;SPACE$(50);
  IF contbit1=0 THEN GRAPHIC PRINT SPACE$(50)
  GRAPHIC COLOR fuc
  GOTO acx
 END IF

 IF nbit<>nbitold THEN
  acx:
 IF tn(10)="Hide" THEN
  bti=BIT(x((nbit)\56),(nbit) MOD 56)
  FONT NEW tipo,28,0,0,0,0 TO fhndl
  GRAPHIC SET FONT fhndl

IF corp=0 THEN
  xat=GRAPHIC(TEXT.SIZE.X,"0")
  yat=GRAPHIC(TEXT.SIZE.Y,"0")
  FOR i=0 TO yat
   FOR u=0 TO xat
    GRAPHIC GET PIXEL (u,i) TO corp
    IF corp=corkey(bti) THEN yat1=i
    GRAPHIC GET PIXEL (u,yat-i) TO corp
    IF corp=corkey(bti) THEN yat2=i
   NEXT
  NEXT
  yat=160+(84-yat-yat1-yat2)/2
END IF

  IF nbit=0 THEN GRAPHIC BOX (186,161)-(358,243),,%RGB_DARKGRAY,%RGB_DARKGRAY
  snbit=RIGHT$(SPACE$(8)+STR$(nbit),8)


  GRAPHIC COLOR (1-bti)*%RGB_LIGHTGRAY,%RGB_DARKGRAY
  GRAPHIC SET POS (346+1-GRAPHIC(TEXT.SIZE.X,snbit),yat+1)
  GRAPHIC PRINT snbit


   GRAPHIC COLOR corkey(bti),-2
  GRAPHIC SET POS (346-GRAPHIC(TEXT.SIZE.X,snbit),yat)
  GRAPHIC PRINT snbit

 END IF

  FONT NEW tipo,8,0,0,0,0 TO fhndl
  GRAPHIC SET FONT fhndl
  GRAPHIC COLOR %RGB_DIMGRAY,fbot
  nbitold=nbit
 END IF

 LOOP

END IF

RETURN


REM ----------------------------------------------------------------------------------------------------------------
filetype:
 GRAPHIC BOX(295,11)-(327,46),,ftop1,ftop1
 IF mfp=0 THEN GRAPHIC BOX(298,21)-(324,46),,ftop1,ftop1
 IF mfp>0 THEN
  GRAPHIC BOX(300,25)-(322,46),,corfile(w(fileposi)),ftop1
  GRAPHIC BOX(301,26)-(321,45),,corfile(w(fileposi)),ftop1
  GRAPHIC BOX(304,29)-(318,42),,corfile(w(fileposi)),corfile(w(fileposi))
  GRAPHIC BOX(306,31)-(316,40),,ftop1,ftop1
 END IF

 IF w(fileposi)=0 OR w(fileposi)=2 THEN
  mais:
  GRAPHIC BOX (122,15)-(141,28),40,fuc
  GRAPHIC BOX (123,17)-(140,28),40,ftop1,ftop1
  GRAPHIC BOX (122,21)-(124,28),,ftop1,ftop1
  GOTO mais1
 END IF

  GRAPHIC BOX (122,15)-(141,28),,ftop1,ftop1
  GRAPHIC BOX (122,18)-(141,31),40,fuc,fuc
  GRAPHIC BOX (123,19)-(140,31),40,ftop1,ftop1
  mais1:
  GRAPHIC BOX (120,26)-(143,46),,fuc
  GRAPHIC BOX (121,27)-(142,30),,ftop1,ftop1

RETURN

REM ---------------------------------------------------------------------
STATISTICS:

IF mfp=0 THEN lista
  IF w(fileposi)<2 AND sizeold=0 THEN  GOSUB verfile

IF showed<>"statistics" THEN GOSUB limpa
showed="statistics"
RESET mensagem()
mensagem(0)="Statistics"
GOSUB escremen

 GRAPHIC COLOR corfile(w(fileposi)),ftop
 GRAPHIC SET POS (25,90)
 GRAPHIC PRINT Listing(fileposi).filename+SPACE$(200)

 temp=DIR$ (Listing(fileposi).FileName, 18, TO Listing(fileposi))
 IF oldstatfile=Listing(fileposi).filename AND StatWriteTime=Listing(fileposi).LastWriteTime THEN
   ist=iold
   mensagem(0)=""
   GOSUB escremen
   GOTO linha2
 END IF


  oldname=Listing(fileposi).filename
  oldstatdir=cudi
  StatWriteTime=Listing(fileposi).LastWriteTime

  ist=0
  iold=0


RANDOMIZE (fileposi+1)*Listing(fileposi).CreationTime
GOSUB verfile
 sizeold=LOF(1)

 RESET pii,somacorrel1,somacorrel2,somachar,chi,entropy,somabit,freqchar(),ru()
 totalbits=8*LOF(1)

lb=0
RANDOMIZE TIMER

IF LOF(1)<=65520000 THEN
  filememstat=NUL$(LOF(1))
  GET$ 1,LOF(1),filememstat
 adr=STRPTR(filememstat)
 FOR ust=adr TO adr+LEN(filememstat)-2 STEP 2
  freqchar(PEEK (ust))+=1
  freqchar(PEEK (ust+1))+=1
  somacorrel1+=16*(PEEK(ust)*PEEK(ust+1)-128*(PEEK(ust)+PEEK(ust+1))+16384)
  somacorrel2+=(PEEK(ust)*PEEK(ust+1)-128*PEEK(ust+1)+524288)
  IF PEEK(ust)*PEEK(ust) + PEEK(ust+1)*PEEK(ust+1) <= piq THEN pii+=8
 NEXT
 GOTO apx
END IF

SEEK 1,0
uu=tss\blksize

FOR ist=0 TO uu
 GET$ 1,blksize,block
 blkk=LEN(block)
 IF mensagem(0)<>FORMAT$(ist/uu*100,"###")+"%" THEN
  mensagem(0)=FORMAT$(ist/uu*100,"###")+"%"
  GRAPHIC COLOR rodacor
  GRAPHIC SET POS (25,ysize-2.3*altura+21)
  GRAPHIC PRINT mensagem(0)
  GRAPHIC COLOR corfile(0),ftop
 END IF

 GetCursorPos Mousepoint
 ScreenToClient hWin, MousePoint

 k=GRAPHIC$(INKEY$)
 IF k=$ESC THEN
  oldstatfile=""
  CLOSE
  GOTO escapar
 END IF


 IF lb=0 AND mold<>mousepoint.x*mousepoint.y THEN
  IF mousepoint.y<80 THEN GRAPHIC LINE (px1old,52)-(px2old,52),ftop1:mold=mousepoint.x*mousepoint.y

   IF mousepoint.y=>0 AND mousepoint.y<56 AND mousepoint.x>0 AND mousepoint.x<495 THEN
   px1=0
   IF mousepoint.x=>28  AND  mousepoint.x<=68 THEN px1=28:px2=68
   IF mousepoint.x=>69  AND mousepoint.x<=110 THEN px1=69:px2=110
   IF mousepoint.x=>111 AND mousepoint.x<=151 THEN px1=111:px2=151
   IF mousepoint.x=>152 AND mousepoint.x<=199 THEN px1=152:px2=199
   IF mousepoint.x=>200 AND mousepoint.x<=242 THEN px1=200:px2=242
   IF mousepoint.x=>243 AND mousepoint.x<=288 THEN px1=243:px2=288
   IF mousepoint.x=>289 AND mousepoint.x<=334 THEN px1=289:px2=334
   IF mousepoint.x=>335 AND mousepoint.x<=376 THEN px1=335:px2=377
   IF mousepoint.x=>377 AND mousepoint.x<=419 THEN px1=377:px2=419
   IF mousepoint.x=>420 AND mousepoint.x<=458 THEN px1=418:px2=456
   IF mousepoint.x=>457 AND mousepoint.x<=497 THEN px1=457:px2=497

   IF  px1<>0 THEN
    GRAPHIC LINE (px1old,52)-(px2old,52),ftop1
    GRAPHIC LINE (px1,52)-(px2,52),fbot
    px1old=px1:px2old=px2
   END IF
  END IF
 END IF

  rmk:
  IF lb=1 AND mousepoint.y=>0 AND mousepoint.y<56 THEN
   IF mousepoint.x=>200 AND mousepoint.x<=242 THEN px1=200:px2=242:lb=0:EXIT IF
   IF mousepoint.x=>335 AND mousepoint.x<=376 THEN lb=0:GRAPHIC WINDOW MINIMIZE:EXIT IF
   IF mousepoint.x<=495 THEN lb=0:GOTO mousepressed
   IF mousepoint.x>495 THEN lb=0:GOTO rmk
  END IF

 FOR ust=STRPTR(block) TO STRPTR(block)+blkk-2 STEP 2
  freqchar(PEEK (ust))+=1
  freqchar(PEEK (ust+1))+=1
  somacorrel1+=16*(PEEK(ust)*PEEK(ust+1)-128*(PEEK(ust)+PEEK(ust+1))+16384)
  somacorrel2+=(PEEK(ust)*PEEK(ust+1)-128*PEEK(ust+1)+524288)
  IF PEEK(ust)*PEEK(ust) + PEEK(ust+1)*PEEK(ust+1) <= piq THEN pii+=8
 NEXT

NEXT

CLOSE

apx:

 freqchar(PEEK(ust))+=(LOF(1) MOD 2)
 mensagem(0)=""
 GOSUB escremen

maxfreq=0
REM Chi square distribution and Entropy and number of bits

FOR ist=0 TO 255
 somachar+=freqchar(ist)*ist
 somabit+=freqchar(ist)*bitum(ist)
 chi+=((freqchar(ist)-sizeold/256)^2)/(sizeold/256)
 entropy-=freqchar(ist)/sizeold*LOG2(freqchar(ist)/sizeold)
 IF freqchar(ist)>maxfreq THEN maxfreq=freqchar(ist)
NEXT



REM Serial correlation
correl=somacorrel1/somacorrel2

REM Monte Carlo PI
montecarlopi=pii/(sizeold)+.009
IF 4-montecarlopi<.000001 THEN montecarlopi=4

REM aritmetic media
media=somachar/sizeold

stc(0)=LTRIM$(FORMAT$(sizeold,"### ### ### ### ###"),ANY " ")
stc(1)=FORMAT$(entropy,"0.000000")
stc(2)=FORMAT$(chi,"0.00")
stc(3)=FORMAT$(media,"0.0000")
stc(4)=FORMAT$(montecarlopi,"0.000000000")
stc(5)=FORMAT$(correl,"0.000000;-0.000000")
stc(6)=LTRIM$(FORMAT$(totalbits-somabit,"### ### ### ### ###"), ANY " ")
stc(7)=LTRIM$(FORMAT$(somabit,"### ### ### ### ###"),ANY " ")


IF entropy>7.99 THEN re(1)=1 ELSE re(1)=0
IF chi>170 AND chi<330 THEN re(2)=1 ELSE re(2)=0
IF media>124 AND media<131 THEN re(3)=1 ELSE re(3)=0
IF montecarlopi>3.13 AND montecarlopi<3.17 THEN re(4)=1 ELSE re(4)=0
IF correl>-.005 AND correl<.005 THEN re(5)=1 ELSE re(5)=0
IF (totalbits-somabit)/totalbits>0.49 AND (totalbits-somabit)/totalbits<0.51 THEN re(6)=1 ELSE re(6)=0
re(7)=re(6)

oldname=Listing(fileposi).filename
oldstatfile=Listing(fileposi).filename

IF mousepoint.y>66 THEN GRAPHIC LINE (px1,52)-(px2,52),ftop1

altu=altura

linha2:
 GRAPHIC COLOR corfile(0),ftop

 FOR ist=0 TO 255
  str(ist)=LTRIM$(FORMAT$(freqchar(ist),"### ### ### ### ###"),ANY " ")
  IF freqchar(ist)>sizeold/256-.08*sizeold/256 AND freqchar(ist)<sizeold\256+.08*sizeold/256 THEN ru(ist)=1 ELSE ru(ist)=0
  IF freqchar(ist)>0 THEN GRAPHIC LINE (25+4*ist,486)-(25+4*ist, 485-200*freqchar(ist)/maxfreq),fuc
 NEXT

 ist=iold
 IF freqchar(ist)>0 THEN  GRAPHIC LINE (25+4*ist,486)-(25+4*ist, 485-200*freqchar(ist)/maxfreq),%WHITE

 FOR ust=1 TO 8
  GRAPHIC SET POS (140-GRAPHIC(TEXT.SIZE.X, stn(ust)),130+(ust-1)*(altu-5))
  GRAPHIC PRINT stn(ust)
  GRAPHIC SET POS (170,130+(ust-1)*(altu-5))
  GRAPHIC PRINT stc(ust)
  GRAPHIC SET POS (150,130+(ust-1)*(altu-5))
  GRAPHIC PRINT ri(re(ust))
 NEXT


  GRAPHIC SET POS (170,130+7*(altu-5))
  GRAPHIC PRINT str(ist)

  GRAPHIC SET POS (330,130+3*(altu-5))
  GRAPHIC PRINT "File size"

  GRAPHIC SET POS (410,130+3*(altu-5))
  GRAPHIC PRINT stc(0)+" Bytes"

  GRAPHIC SET POS (330,130+4*(altu-5))
  GRAPHIC PRINT "Binary"

  GRAPHIC SET POS (330,130+5*(altu-5))
  GRAPHIC PRINT "Hexadecimal"

  GRAPHIC SET POS (330,130+6*(altu-5))
  GRAPHIC PRINT "Decimal"

  GRAPHIC SET POS (330,130+7*(altu-5))
  GRAPHIC PRINT "Character"

  GRAPHIC COLOR fuc
  GOTO linha3


DO
  uu=lb
  IF uu=1 AND mousepoint.x=>25 AND mousepoint.x<xsize-25 AND mousepoint.y=>285 AND mousepoint.y<=486 THEN kytr
  IF lb=1 THEN GOSUB MOUSEPRESSED:lb=0
DO

 parstat:
 mold=mousepoint.x*mousepoint.y
 GetCursorPos Mousepoint
 ScreenToClient hWin, MousePoint
 IF GetAsyncKeyState(%vk_F1) THEN showed="Ajuda":GOTO ajuda

IF mousepoint.y=>480 AND mousepoint.y<=670 THEN
 IF mousepoint.x<25 THEN ist=0:GOTO linhas
 IF mousepoint.x>xsize-25 THEN ist=255:GOTO linhas
END IF

 IF hVin=0 THEN Exitprog
 GRAPHIC INKEY$ TO k
 IF LEN(k)=2 THEN spl

  temp=DIR$ (Listing(fileposi).FileName, 18, TO Listing(fileposi))
  IF StatWriteTime<>Listing(fileposi).LastWriteTime THEN
   CLOSE
   GOTO escapar
  END IF

LOOP UNTIL mold<>mousepoint.x*mousepoint.y OR k<>"" OR lb=1

IF lb=1 AND mousepoint.y=>0 AND mousepoint.y<56 AND mousepoint.x=>335 AND mousepoint.x<=376 THEN lb=0:GRAPHIC WINDOW MINIMIZE



IF lb=1 AND mousepoint.x<=495 AND mousepoint.y<56 THEN
 IF mousepoint.x=>200 AND mousepoint.x<=242 THEN parstat
  lb=0
  GOTO mousepressed
 END IF

 IF lb=0 AND mousepoint.x>495 AND mousepoint.y<56 THEN GRAPHIC LINE (px1old,52)-(px2old,52),ftop1
 IF %WM_LBUTTONDOWN AND mousepoint.x>495 AND mousepoint.y<56 THEN lb=0:GOTO parstat

  IF mold<>mousepoint.x*mousepoint.y THEN
   IF mousepoint.y<80 THEN GRAPHIC LINE (px1old,52)-(px2old,52),ftop1:mold=mousepoint.x*mousepoint.y
    IF mousepoint.y=>0 AND mousepoint.y<56 AND mousepoint.x>0 AND mousepoint.x<495 THEN

    px1=0
    IF mousepoint.x=>28  AND  mousepoint.x<=68 THEN px1=28:px2=68
    IF mousepoint.x=>69  AND mousepoint.x<=110 THEN px1=69:px2=110
    IF mousepoint.x=>111 AND mousepoint.x<=151 THEN px1=111:px2=151
    IF mousepoint.x=>152 AND mousepoint.x<=199 THEN px1=152:px2=199
    IF mousepoint.x=>200 AND mousepoint.x<=242 THEN px1=200:px2=242
    IF mousepoint.x=>243 AND mousepoint.x<=288 THEN px1=243:px2=288
    IF mousepoint.x=>289 AND mousepoint.x<=334 THEN px1=289:px2=334
    IF mousepoint.x=>335 AND mousepoint.x<=376 THEN px1=335:px2=377
    IF mousepoint.x=>377 AND mousepoint.x<=419 THEN px1=377:px2=419
    IF mousepoint.x=>420 AND mousepoint.x<=458 THEN px1=418:px2=456
    IF mousepoint.x=>457 AND mousepoint.x<=497 THEN px1=457:px2=497

    IF  px1<>0 THEN
     GRAPHIC LINE (px1old,52)-(px2old,52),ftop1
     GRAPHIC LINE (px1,52)-(px2,52),fbot
     px1old=px1:px2old=px2
    END IF
   END IF
 END IF

 kytr:
 IF k="" AND uu=1 AND mousepoint.x=>25 AND mousepoint.x<xsize-25 AND mousepoint.y=>285 AND mousepoint.y<=486 THEN
  ist=(mousepoint.x-25)\4
  IF ist>255 THEN ist=255
  IF ist<0 THEN ist=0
  IF ist<>iold THEN linhas
 END IF

IF k=$ESC THEN escapar
IF LEN(k)=1 THEN ist=ASC(k):GOTO linhas

IF k<>"" AND LEN(k)=2 THEN
    spl:
 k=RIGHT$(k,1)
 IF k="K" THEN ist-=1
 IF k="M" THEN ist+=1
 IF k="G" THEN ist=0
 IF k="O" THEN ist=255
 IF k="I" THEN ist+=8
 IF k="Q" THEN ist-=8
 IF ist>255 THEN ist=255
 IF ist<0 THEN ist=0

 linhas:
 IF ist<>iold THEN
 IF uu=1 OR k<>"" THEN
   linha3:
   IF freqchar(iold)>0 THEN ustold=(4*iold+25):GRAPHIC LINE (ustold,486)-(ustold, 485-200*freqchar(iold)/maxfreq),fuc
   IF freqchar(ist)>0  THEN  ustold=(4*ist+25):GRAPHIC  LINE (ustold,486)-(ustold, 485-200*freqchar(ist)/maxfreq),%WHITE
   iold=ist
   GRAPHIC SET POS (170,130+7*(altu-5))
   GRAPHIC PRINT str(ist);SPACE$(35-LEN(str(ist)))

   GRAPHIC SET POS (150,130+7*(altu-5))
   GRAPHIC PRINT ri(ru(ist))

   GRAPHIC SET POS (410,130+4*(altu-5))
   GRAPHIC PRINT RIGHT$("00000000"+BIN$(ist),8)
   GRAPHIC SET POS (410,130+5*(altu-5))
   GRAPHIC PRINT RIGHT$("0"+HEX$(ist),2);SPACE$(10)
   GRAPHIC SET POS (410,130+6*(altu-5))
   GRAPHIC PRINT RIGHT$("00"+LTRIM$(STR$(ist),ANY " "),3);SPACE$(10)
   GRAPHIC SET POS (410,130+7*(altu-5))
   GRAPHIC PRINT car(ist);SPACE$(50)
  END IF

 END IF

  mold=mousepoint.x*mousepoint.y
 END IF

LOOP

CLOSE
GOTO nodo

RETURN


REM -----------------------------------------------------------------------------------------
LIMPA:
  GRAPHIC BOX (-4,62)-(xsize+4,ysize-2.0*altura),,fbot,fbot
  SetRect rc, -4, 58, xsize+4, 62
  hHoleRgn = CreateRectRgn(rc.nLeft, rc.nTop, rc.nRight, rc.nBottom)
  CreateHole(hWin, hHoleRgn)
RETURN

REM -----------------------------------------------------------------------------------
FLOATS:

RESET mensagem()
GOSUB escremen
showed="floats"
nfloats=50001
nflot=0
GOSUB limpa

REM csprng floating point by Ribeiro Alvo
clio=SPACE$(20*nfloats)
RESET x(),a,b,c
  b=FRAC(TIMER)*n
  FOR i=0 TO n
   a+=b+1
   c+=a+1
   b+=c+1
   x(i)=(x(i)+a*b*c*i+i) MOD m
  NEXT

 block=NUL$(21)
 p=STRPTR(block)
 GRAPHIC COLOR fuc,fbot

FOR i=0 TO nfloats+1 STEP 3
  x(a)=(x(b)+x(c))
  BIT RESET x(a),62
  a+=b+i
  POKE QUAD,p,   ( x(a) + x(b) )
  c+=a
  POKE QUAD,p+7, ( x(c) + x(a) )
  b+=c
  POKE QUAD,p+14,( x(b) + x(c) )

  fx=ABS(PEEK(QUAD,p)/(2^63-1))
  fy=ABS(PEEK(QUAD,p+6)/(2^63-1))
  fz=ABS(PEEK(QUAD,p+12)/(2^63-1))

  fw(i)=fx
  fw(i+1)=fy
  fw(i+2)=fz

  MID$(clio,(i+0)*20+1,20)=LEFT$(FORMAT$(ABS(fx),"#.################")+SPACE$(20),18)+$CRLF
  MID$(clio,(i+1)*20+1,20)=LEFT$(FORMAT$(ABS(fy),"#.################")+SPACE$(20),18)+$CRLF
  MID$(clio,(i+2)*20+1,20)=LEFT$(FORMAT$(ABS(fz),"#.################")+SPACE$(20),18)+$CRLF

NEXT

RANDOMIZE TIMER

  GRAPHIC SET POS (112,ysize-3*altura+21)
  GRAPHIC PRINT "Generating..."

u=0
DO
  ii=RND(0,30)
  GRAPHIC BOX (112+28*ii,490-fw(u)*350)-(137+28*ii,130),,fbot,fbot
  GRAPHIC BOX (112+28*ii,490)-(137+28*ii,486-fw(u)*350),,&h878e96 ,%RGB_DIMGRAY
 INCR u
 FOR uu=0 TO 1000000:NEXT
LOOP UNTIL u=200

  GRAPHIC SET POS (112,ysize-3*altura+21)
  GRAPHIC PRINT LTRIM$(FORMAT$(nfloats-1,"## ### ###"),ANY " ")+" pseudo random numbers"

CLIPBOARD SET TEXT clio
  RESET x(),a,b,c
  block=""
  p=0
  GOTO espera
RETURN

REM -----------------------------------------------------------------------------------
ESCREMEN:

 nret =  gcd (2048, Cudi)
 GRAPHIC BOX (0,ysize-2*altura)-(xsize,ysize),,fbot,fbot
 GRAPHIC COLOR rodacor
 GRAPHIC SET POS (25,ysize-3*altura+21)
 GRAPHIC PRINT mensagem(0)+SPACE$(400)
 GRAPHIC SET POS (25,ysize-2.3*altura+21)
 GRAPHIC PRINT mensagem(1)+SPACE$(400)
 GRAPHIC COLOR corfile(0),ftop

RETURN

REM ----------------------------------------------------------
PRINTERRO:
IF crypt=0 THEN
 GRAPHIC COLOR rodacor,fbot
 GRAPHIC SET POS (25,ysize-2.3*altura+21)
 GRAPHIC PRINT men+SPACE$(100)
 SLEEP 1000
 k=""
 oldir=""
 GOTO lista
END IF

printer:
GRAPHIC COLOR rodacor,ftop
GRAPHIC SET POS (25,ysize-2.3*altura+21)
GRAPHIC PRINT men+SPACE$(100)
SLEEP 1000
GRAPHIC SET POS (25,ysize-2.3*altura+21)
IF sizeold>0 THEN GRAPHIC PRINT LTRIM$(FORMAT$(sizeold,"### ### ### ###"),ANY " ")+" Bytes"+SPACE$(50)
IF sizeold=0 THEN GRAPHIC PRINT SPACE$(100)
GOSUB escremen
men=""

GRAPHIC COLOR corfile(0),fbot
GOTO lista

RETURN

REM --------------------------------------------------------------------------
MAKEMENU:

GRAPHIC BOX (0,0)-(xsize,56),,ftop1,ftop1

REM browse

pap=0
GRAPHIC BOX (36,19)-(41,24),,corfile(0)
FOR u=0 TO 20 STEP 10
 FOR i=0 TO 20 STEP 10
  cori=fuc
  IF pap=4 THEN cori=corfile(1)
  IF pap=2 OR pap=6 THEN cori=corfile(2)
   GRAPHIC BOX (34+i,17+u)-(43+i,26+u),,cori
  INCR pap
 NEXT
NEXT

REM Down in tree

 GRAPHIC LINE (85,41)-(94,41),corfile(0)
 GRAPHIC  BOX (96,17)-(105,26),,corfile(1)
 GRAPHIC  BOX (96,27)-(105,36),,corfile(0)
 GRAPHIC  BOX (96,37)-(105,46),,corfile(2)
 GRAPHIC  BOX (74,37)-(83,46),,corfile(2)
 GRAPHIC  BOX (98,39)-(103,44),,corfile(2)

 FOR i=79 TO 82
  GRAPHIC LINE (i-3+8,44-3-(i-79))-(i-3+8,44-3+(i-79)),fuc
 NEXT

REM lock is drawn in filetype:

REM statistics

RANDOMIZE 0
 GRAPHIC BOX (204,45)-(240,15),,ftop1,ftop1
 FOR i=0 TO 34 STEP 2
  GRAPHIC LINE (204+i,45)-(204+i,45-25*RND),fuc
 NEXT

REM floats

FOR i=252 TO 280 STEP 4
  GRAPHIC BOX (i,46)-(i+3,46-RND(2,35)),,fbot,fbot
NEXT

REM ler
GRAPHIC LINE (131,33)-(131,39),fuc
GOSUB filetype

REM minimo
GRAPHIC LINE (339,45)-(374,45),fuc

REM Help

GRAPHIC BOX (394,25)-(400,46),,fuc
GRAPHIC BOX (394,18)-(400,23),,fuc

REM Lixo
GRAPHIC BOX (425,22)-(447,46),,fuc
GRAPHIC BOX (426,21)-(446,45),,ftop1,ftop1
GRAPHIC LINE (422,19)-(450,19),fuc
GRAPHIC LINE (431,16)-(441,16),fuc

FOR i=0 TO 5
 GRAPHIC LINE (428+3*i,23)-(428+3*i,43),fuc
NEXT

REM Exit
 GRAPHIC LINE (488,21)-(464,45),fuc
 GRAPHIC LINE (488,44)-(464,20),fuc

REM caixa
GRAPHIC BOX(159,14)-(192,47),,fuc,fuc

caixa:

FOR ic=0 TO 2
 FOR uc=0 TO 2
  GRAPHIC BOX(158+uc*12,37-ic*12)-(169+uc*12,48-ic*12),,ftop1,ftop1
  IF crypt>3*ic+uc THEN GRAPHIC BOX (160+uc*12,38-ic*12)-(168+uc*12,46-ic*12),,corfile(1)
 NEXT
NEXT
rpl:
cryptold=crypt

RETURN

REM ----------------------------------------------------------------------------------------------------------------
FINDFILES:

IF cont>0 THEN RETURN
INCR cont
RESET w(),ndirs,nfiles,Listing(),crypt,mfp

mensagem(0)=Cudi

IF cont=-1 THEN mensagem(0)=""
IF ini<>0 THEN GOSUB escremen
ini=10

cont=0
temp=DIR$ ("*.*", 18, TO Listing(mfp))

 DO WHILE NOT temp=""
  IF (Listing(mfp).fileAttributes AND 16)=16 THEN INCR ndirs::w(mfp)=2:GOTO ntr

  IF Listing(mfp).FileSizeLow=0 OR LEFT$(UCASE$(Listing(mfp).Filename),5)=UCASE$("Melgo") THEN ntr2

  IF RIGHT$(Listing(mfp).filename,1)=CHR$$(8203) THEN w(mfp)=1:crypt+=1

  ntr:
  mfp+=1
  ntr2:
  temp= DIR$(NEXT TO Listing(mfp))
 LOOP


mtp=mfp
lim=MIN(mfp,17)

IF crypt<>cryptold THEN GOSUB caixa

RETURN

REM ----------------------------------------------------------------------------------------------------
LER:


 GRAPHIC COLOR corfile(w(fileposi)),fbot
 GRAPHIC SET POS (25,90)
 GRAPHIC PRINT Listing(fileposi).filename+SPACE$(200)


  RESET mensagem()
  GOSUB escremen
  mensagem(1)="Opening the file."
  GOSUB escremen

  showed="ler"
  GOSUB verfile
  lb=0
  RESET mensagem()
  GOSUB escremen

IF sizeold>2^30-43 THEN
 mensagem(0)=""
 mensagem(1)="File to big"
 GOSUB escremen
 SLEEP 1000
 GOSUB escapar
END IF

GRAPHIC COLOR corfile(0),fbot

xtex = GRAPHIC(TEXT.SIZE.X, CHR$(87))*1.6
tlin=42
altlin=20
desl=(xsize-tlin-140)/2-16

 plin=0
 plinold=1
 idesl=desl+18
 slin=18*tlin


GRAPHIC COLOR fuc,fbot

GRAPHIC COLOR corfile(w(fileposi)),%RGB_DARKGRAY
GRAPHIC BOX  (2+desl,113)-(38+desl+tlin*xtex+3,ysize-3*altlin+10),,corfile(w(fileposi)),%RGB_DARKGRAY
GRAPHIC BOX  (4+desl,115)-(36+desl+tlin*xtex+3,ysize-3*altlin+8),,fbot

oldname=Listing(fileposi).filename

 SEEK 1,0
 GET$ 1,blksize,block
 SEEK 1,0
 plin=0

  ii=0
  FOR i=0 TO 17
   FOR uu=0 TO tlin-1
    IF plin+ii+uu=>blksize THEN EXIT
    GRAPHIC SET POS (idesl-9+(uu+1)*xtex,125+i*altlin)
    IF ASC(MID$(block,plin+ii+uu+1,1))>31 THEN GRAPHIC PRINT MID$(block,plin+ii+uu+1,1);"   "
    IF ASC(MID$(block,plin+ii+uu+1,1))<=31 THEN GRAPHIC PRINT CHR$$(&h2700+ASC(MID$(block,plin+ii+uu+1,1)));"   "
   NEXT
   ii+=tlin
  NEXT

IF integral=0 THEN filememler=""
IF oldlerfile<>Listing(fileposi).filename OR LerWriteTime<>Listing(fileposi).LastWriteTime OR integral<>100 THEN filememler=NUL$(sizeold)+SPACE$(42-sizeold MOD 42)

adr=STRPTR(filememler)

plin=0
plinold=1
cump=LEN(filememler)
idesl=desl+18
slin=18*tlin

posbyte=0
posbyteold=1
oldposbyte=1

 temp=DIR$ (Listing(fileposi).FileName, 18, TO Listing(fileposi))
 IF integral=100 AND oldlerfile=Listing(fileposi).filename AND LerWriteTime=Listing(fileposi).LastWriteTime THEN GOTO tepe

LerWriteTime=Listing(fileposi).LastWriteTime
oldlerfile=Listing(fileposi).filename
integral=0

 GRAPHIC COLOR rodacor,fbot
FOR u=0 TO tss STEP blksize

 GET$ 1,blksize,block
 blkk=LEN(block)
 IF hVin=0 THEN Exitprog
 POKE$ adr+u, block
 GRAPHIC INKEY$ TO k
 IF k=$ESC THEN
   CLOSE
   GOTO saiu
 END IF

 GetCursorPos Mousepoint
 ScreenToClient hWin, MousePoint

 IF mousepoint.x<28 OR mousepoint.x>494 THEN GRAPHIC LINE (px1old,52)-(px2old,52),ftop1 :mold=mousepoint.x*mousepoint.y
 IF mousepoint.y<62 AND mold<>mousepoint.y*mousepoint.x THEN px1old=0:GRAPHIC LINE (px1old,52)-(px2old,52),ftop1

 IF mousepoint.y=>0 AND mousepoint.y<56 THEN

  px1=0
  IF mousepoint.x<28 AND lb=1 THEN mousepressed
  IF mousepoint.x=>28  AND  mousepoint.x<=68 THEN px1=28:px2=68
  IF mousepoint.x=>69  AND mousepoint.x<=110 THEN px1=69:px2=110
  IF mousepoint.x=>111 AND mousepoint.x<=151 THEN px1=111:px2=151
  IF mousepoint.x=>152 AND mousepoint.x<=199 THEN px1=152:px2=199
  IF mousepoint.x=>200 AND mousepoint.x<=242 THEN px1=200:px2=242
  IF mousepoint.x=>243 AND mousepoint.x<=288 THEN px1=243:px2=288
  IF mousepoint.x=>289 AND mousepoint.x<=334 THEN px1=289:px2=334
  IF mousepoint.x=>335 AND mousepoint.x<=376 THEN px1=335:px2=377
  IF mousepoint.x=>377 AND mousepoint.x<=419 THEN px1=377:px2=419
  IF mousepoint.x=>420 AND mousepoint.x<=458 THEN px1=418:px2=456
  IF mousepoint.x=>457 AND mousepoint.x<=497 THEN px1=457:px2=497

  IF  px1<>0 THEN
    GRAPHIC LINE (px1old,52)-(px2old,52),ftop1
    GRAPHIC LINE (px1,52)-(px2,52),fbot
    px1old=px1:px2old=px2

  IF lb=1 THEN
    IF mousepoint.x=>289 AND mousepoint.x<=334 THEN px1=289:px2=334:EXIT IF
    IF mousepoint.x=>335 AND mousepoint.x<=376 THEN px1=335:px2=377:lb=0:GRAPHIC WINDOW MINIMIZE:EXIT IF
    GOSUB mousepressed
   END IF
   END IF
 END IF

 GRAPHIC SET POS (25,ysize-2.3*altura+21)
 GRAPHIC PRINT FORMAT$(u/sizeold*100,"###,##")+"% loaded "

NEXT

CLOSE

integral=100

tepe:

GRAPHIC COLOR corfile(w(fileposi)),fbot
mensagem(1)=""
GOSUB escremen


DO
 topo:
 GetCursorPos Mousepoint
 ScreenToClient hWin, MousePoint
 IF GetAsyncKeyState(%vk_F1) THEN showed="Ajuda":GOTO ajuda

  temp=DIR$ (Listing(fileposi).FileName, 18, TO Listing(fileposi))
  IF LerWriteTime<>Listing(fileposi).LastWriteTime THEN
   CLOSE
   GOTO saiu
  END IF

 IF lb>0 AND mousepoint.y AND oldmouse<>mousepoint.x*mousepoint.y THEN
  IF plin+posbyte+1>sizeold THEN lb=0:EXIT IF
  oldmouse=mousepoint.x*mousepoint.y
  GRAPHIC SET POS (90,ysize-2*altura-2)
  GRAPHIC COLOR corfile(w(fileposi)),fbot
  GRAPHIC PRINT SPACE$(300)
  GRAPHIC BOX (3+desl+xtex+(oldposbyte MOD 42)*xtex , 122+(oldposbyte\42 MOD 18-1)*altlin+altlin)- (23+desl+xtex+(oldposbyte MOD 42)*xtex , 122+(oldposbyte\42 MOD 18-1)*altlin+2*altlin),,%RGB_DARKGRAY
  IF lb=2 AND sizeold>756 THEN tre
 END IF

  IF lb=1 AND mousepoint.x>desl+xtex+6 AND mousepoint.x<37+desl+tlin*xtex-xtex AND mousepoint.y=>118 AND mousepoint.y<=ysize-3*altlin THEN
   IF plin+posbyte+1>sizeold THEN lb=0:EXIT IF
   GRAPHIC BOX (3+desl+xtex+(oldposbyte MOD 42)*xtex , 122+(oldposbyte\42 MOD 18-1)*altlin+altlin)- (23+desl+xtex+(oldposbyte MOD 42)*xtex , 122+(oldposbyte\42 MOD 18-1)*altlin+2*altlin),,%RGB_DARKGRAY
   GRAPHIC BOX (3+desl+xtex+(posbyte MOD 42)*xtex , 122+(posbyte\42 MOD 18-1)*altlin+altlin)- (23+desl+xtex+(posbyte MOD 42)*xtex , 122+(posbyte\42 MOD 18-1)*altlin+2*altlin),,fbot

   oldposbyte=posbyte
   GRAPHIC COLOR %RGB_DARKGRAY,fbot
   GRAPHIC SET POS (177,ysize-2*altura-2)
   GRAPHIC PRINT "Bin "+Bina(PEEK(adr+plin+posbyte))+"          Dec"+ STR$(PEEK(adr+plin+posbyte))+"          Hex "+HEX$(PEEK(adr+plin+posbyte));
   IF PEEK(adr+plin+posbyte)<33 THEN GRAPHIC PRINT "          "+car(PEEK(adr+plin+posbyte));

   GRAPHIC SET POS(885-GRAPHIC(TEXT.SIZE.X,"Position "+LTRIM$(FORMAT$(plin+posbyte+1,"## ### ### ###"))),ysize-2*altura-2)
   GRAPHIC PRINT "Position ";LTRIM$(FORMAT$(plin+posbyte+1,"## ### ### ###"));SPACE$(300)
   lb=0
  END IF

 IF lb=1 AND mousepoint.x=>289 AND mousepoint.x<=334 THEN lb=0
 IF lb=1 THEN lb=0:GOSUB mousepressed:lb=0

 IF  mousepoint.x<28 OR mousepoint.x>494 AND mousepoint.y<66 THEN GRAPHIC LINE (px1old,52)-(px2old,52),ftop1 :mold=mousepoint.x*mousepoint.y

   IF (mousepoint.y>66 OR mousepoint.y<0) AND linclar=1 THEN
    GRAPHIC LINE (px1old,52)-(px2old,52),ftop1
    linclar=0
   END IF

   IF  mousepoint.x<28 OR mousepoint.x>494 AND mousepoint.y<63 THEN px1old=1:GRAPHIC LINE (px1old,52)-(px2old,52),ftop1 :mold=mousepoint.x*mousepoint.y
   IF mousepoint.y>=0 AND mousepoint.y<56 AND mousepoint.x=>28 AND mousepoint.x<=494 THEN

    px1=0
    IF mousepoint.x=>28  AND  mousepoint.x<=68 THEN px1=28:px2=68
    IF mousepoint.x=>69  AND mousepoint.x<=110 THEN px1=69:px2=110
    IF mousepoint.x=>111 AND mousepoint.x<=151 THEN px1=111:px2=151
    IF mousepoint.x=>152 AND mousepoint.x<=199 THEN px1=152:px2=199
    IF mousepoint.x=>200 AND mousepoint.x<=242 THEN px1=200:px2=242
    IF mousepoint.x=>243 AND mousepoint.x<=288 THEN px1=243:px2=288
    IF mousepoint.x=>289 AND mousepoint.x<=334 THEN px1=289:px2=334
    IF mousepoint.x=>335 AND mousepoint.x<=376 THEN px1=335:px2=377
    IF mousepoint.x=>377 AND mousepoint.x<=419 THEN px1=377:px2=419
    IF mousepoint.x=>420 AND mousepoint.x<=458 THEN px1=418:px2=456
    IF mousepoint.x=>457 AND mousepoint.x<=497 THEN px1=457:px2=497

    IF linclar=0 OR px1old<>px1 THEN
      GRAPHIC LINE (px1old,52)-(px2old,52),ftop1
      GRAPHIC LINE (px1,52)-(px2,52),fbot
      px1old=px1:px2old=px2
      linclar=1
    END IF

 END IF

IF lb=2 AND sizeold>756 AND mousepoint.y>56 AND mold<>mousepoint.x*mousepoint.y AND cump>slin AND mousepoint.x>37+desl+tlin*xtex AND mousepoint.x<37+desl+tlin*xtex+200 AND mousepoint.y=>0 AND mousepoint.y<=ysize THEN
  tre:
  mold=mousepoint.x*mousepoint.y
  plin=FIX(tlin*FIX(((mousepoint.y-108)/357*(cump-slin-tlin))/tlin))
  IF plin<0 THEN plin=0
  IF plin>cump-slin THEN plin=cump-slin
  IF plin<>plinold THEN plinold=plin:GOTO rere
END IF

IF lb=0 AND plin<>plinold THEN

 rere:
 ii=-1
 plinold=plin
 GRAPHIC COLOR corfile(w(fileposi)),%RGB_DARKGRAY

 IF k<>"" OR lb=2 AND LEN(filememler)>756 THEN

  GRAPHIC BOX (3+desl+xtex+(oldposbyte MOD 42)*xtex , 122+(oldposbyte\42 MOD 18-1)*altlin+altlin)- (23+desl+xtex+(oldposbyte MOD 42)*xtex , 122+(oldposbyte\42 MOD 18-1)*altlin+2*altlin),,%RGB_DARKGRAY
  FOR i=0 TO 17
   FOR u=1 TO tlin
    GRAPHIC SET POS (idesl-9+u*xtex,125+i*altlin)
    IF PEEK (adr+plin+ii+u)>31 THEN GRAPHIC PRINT PEEK$(adr+plin+ii+u,1);"   "
    IF PEEK (adr+plin+ii+u)<=31 THEN GRAPHIC PRINT CHR$$(&H2700+PEEK (adr+plin+ii+u));"   "
   NEXT
   ii+=tlin
  NEXT

 END IF

END IF

IF  mold<>mousepoint.x*mousepoint.y THEN

  mold=mousepoint.x*mousepoint.y
  posbyteold=-1

 IF mousepoint.x>desl+xtex+6 AND mousepoint.x<37+desl+tlin*xtex-xtex AND mousepoint.y=>118 AND mousepoint.y<=ysize-3*altlin THEN
   posbyte=(((mousepoint.y-122)\altlin) MOD 20)*tlin+(((mousepoint.x-desl-5+xtex)\xtex-2) MOD 43 )
   IF posbyte<cump AND oldmouse=mousepoint.x*mousepoint.y THEN
    IF posbyte<>posbyteold THEN oldmouse=mousepoint.x*mousepoint.y
   END IF
   lb=0
   posbyteold=posbyte
 END IF

END IF

 GRAPHIC INKEY$ TO k
 IF k=$ESC THEN saiu

IF LEN(k)=2 THEN

 plinold=plin
 ky=RIGHT$(k,1)
 posbyteold=-1
 mold=-1

 IF ky="H" THEN ky=".":plin-=tlin
 IF ky="P" THEN ky=".":plin+=tlin
 IF ky="G" THEN plin=0
 IF ky="O" THEN plin=cump-slin
 IF ky="I" THEN plin-=slin
 IF ky="Q" THEN plin+=slin
 IF plin=>cump-slin THEN plin=cump-slin
 IF plin<0 THEN plin=0


 IF plin<>plinold OR lb=2 THEN
  GRAPHIC SET POS (90,ysize-2*altura-2)
  GRAPHIC COLOR corfile(w(fileposi)),fbot
  GRAPHIC PRINT SPACE$(300)
 END IF

END IF
 IF oldlerfile<> DIR$ (Listing(fileposi).filename, 18) THEN saiu
 IF hVin=0 THEN Exitprog

LOOP
saiu:

 GRAPHIC COLOR corfile(0),fbot
CLOSE
GOTO escapar
RETURN


REM LIXO ---------------------------------------------------------------------

LIXO:

k=""
  IF mfp=0 THEN lista

   showed="lixo"
   RESET mensagem()
   GOSUB verfile
   IF FILEATTR(1,0)=0 THEN
    mensagem(1)="File already open"
    GOSUB escremen
    SLEEP 1000
    oldir=""
    GOTO lista
   END IF

 GOSUB limpa

  oldir=""
  mold=0

  GRAPHIC COLOR corfile(w(fileposi))
  GRAPHIC SET POS (25,90)
  GRAPHIC PRINT Listing(fileposi).filename+SPACE$(800)
  corlixo=-1
  GRAPHIC COLOR fuc
  GOTO lex

DO

  IF GetAsyncKeyState(%vk_F1) THEN showed="Ajuda":GOTO ajuda
  IF lb=1 THEN
   IF mousepoint.y=>116 AND mousepoint.y<=146 AND mousepoint.x=>25 AND mousepoint.x<=55 THEN apagar
   IF mousepoint.x=>420 AND mousepoint.x<=458 THEN lb=0
   lb=0:GOSUB mousepressed:lb=0
  END IF

 IF k="" THEN SLEEP 6
 GetCursorPos Mousepoint
 ScreenToClient hWin, MousePoint
 IF mold<>mousepoint.y*mousepoint.x AND px1<>px1old THEN  GRAPHIC LINE (px1old,52)-(px2old,52),corbut1:px1old=px1:px2old=px2
 IF mold<>mousepoint.y*mousepoint.x AND mousepoint.y=>0 AND mousepoint.y<56 THEN
  px1=0
  IF mousepoint.x=>28  AND  mousepoint.x<=68 THEN px1=28:px2=68
  IF mousepoint.x=>69  AND mousepoint.x<=110 THEN px1=69:px2=110
  IF mousepoint.x=>111 AND mousepoint.x<=151 THEN px1=111:px2=151
  IF mousepoint.x=>152 AND mousepoint.x<=199 THEN px1=152:px2=199
  IF mousepoint.x=>200 AND mousepoint.x<=242 THEN px1=200:px2=242
  IF mousepoint.x=>243 AND mousepoint.x<=288 THEN px1=243:px2=288
  IF mousepoint.x=>289 AND mousepoint.x<=334 THEN px1=289:px2=334
  IF mousepoint.x=>335 AND mousepoint.x<=376 THEN px1=335:px2=377
  IF mousepoint.x=>377 AND mousepoint.x<=419 THEN px1=377:px2=419
  IF mousepoint.x=>420 AND mousepoint.x<=458 THEN px1=418:px2=456
  IF mousepoint.x=>457 AND mousepoint.x<=497 THEN px1=457:px2=497
  IF mold<>mousepoint.y*mousepoint.x AND px1<>0 THEN GRAPHIC LINE (px1,52)-(px2,52),fbot

  IF linclar=0 OR px1old<>px1 THEN
    GRAPHIC LINE (px1old,52)-(px2old,52),ftop1
    GRAPHIC LINE (px1,52)-(px2,52),fbot
    px1old=px1:px2old=px2
    linclar=1
     GRAPHIC SET PIXEL (px2old,52),ftop1
  END IF

 END IF
 IF px1=0 OR mousepoint.y<0 OR mousepoint.y>56 THEN GRAPHIC LINE (px1old,52)-(px2old,52),ftop1

 GRAPHIC INKEY$ TO k
 IF k=$ESC THEN sailixo

IF mold<>mousepoint.y*mousepoint.x THEN

IF lb>0 OR (mousepoint.y<62 AND mousepoint.x>497) THEN eyo
 GRAPHIC SET PIXEL (px2old,52),ftop1

 mold=mousepoint.y*mousepoint.x

  IF mousepoint.x=>25  AND  mousepoint.x<=54 AND mousepoint.y=>117-5  AND  mousepoint.y<=146 THEN
   corlixo=%RGB_DARKGRAY
   mensagem(1)="Erase it"
  ELSE
   corlixo=fuc
   lex:
   mensagem(1)=""
  END IF

  IF corlixo<>oldcorlixo THEN
   oldcorlixo=corlixo
   GRAPHIC BOX (28,119)-(50,143),,corlixo
   GRAPHIC BOX (29,118)-(49,142),,fbot,fbot
   GRAPHIC LINE (25,116)-(53,116),corlixo
   GRAPHIC LINE (34,113)-(44,113),corlixo
   FOR i=0 TO 5
    GRAPHIC LINE (31+3*i,120)-(31+3*i,140),corlixo
   NEXT
   GOSUB escremen
  END IF

END IF
eyo:

LOOP

  apagar:

  lb=0
  IF w(fileposi)<2 AND sizeold=0 THEN mata
  GOSUB verfile
  block=NUL$(blksize)
  p=STRPTR(block)
  FOR u=p TO p+blksize
   POKE u,RND*256
  NEXT

   memem=" erased"
  FOR i=0 TO tss\blksize-1
   mensagem(1)=FORMAT$(i*blksize/tss*100,"###,##")+"% "+memem
   GOSUB escremen
   IF hVin=0 THEN Exitprog
   oldpos=LOC(1)
   FOR u=0 TO 9
    SEEK 1,oldpos
    posblk=RND
    block=RIGHT$(block,blksize*posblk)+LEFT$(block,blksize-blksize*posblk)
    PUT$ 1, block
   NEXT
  NEXT

  blksize=sizeold-LOC(1)
  block=NUL$(blksize)
  p=STRPTR(block)
  FOR u=p TO p+blksize
    POKE u,RND*256
  NEXT

   oldpos=LOC(1)
   FOR u=0 TO 9
    SEEK 1,oldpos
    posblk=RND
    block=RIGHT$(block,blksize*posblk)+LEFT$(block,blksize-blksize*posblk)
    PUT$ 1, block
   NEXT

 mata:
  CLOSE 1

  KILL Listing(fileposi).filename
  ly=""

  GRAPHIC COLOR fuc
  GRAPHIC BOX(0,ysize-200)-(200,ysize),,fbot,fbot
  GRAPHIC SET POS (25,ysize-2.3*altura+21)
  GRAPHIC PRINT "File erased"+SPACE$(800)
  SLEEP 1000
  GOSUB findfiles

 sailixo:
 GOTO escapar
RETURN

REM ----------------------------------------------------------------------------------------------------------
REM Find folders, files by first letter end encrypted ones

encontra:
  oldfileposi=fileposi

  FOR fu=fileposi+1 TO mfp-1
   IF proc=0 OR proc=1 OR proc=2 THEN
    IF w(fu)=proc THEN
     fileposi=fu
     GOTO listar
    END IF
   END IF

   IF proc=3 THEN
    IF LEFT$(UCASE$((Listing(fu).filename)),1)=UCASE$(lt) THEN
     fileposi=fu
     GOTO listar
    END IF
   END IF
  NEXT

  FOR fu=0 TO fileposi-1
   IF proc=0 OR proc=1 OR proc=2 THEN
    IF w(fu)=proc THEN
     fileposi=fu
     GOTO listar
    END IF
   END IF

   IF proc=3 THEN
    IF LEFT$(UCASE$((Listing(fu).filename)),1)=UCASE$(lt) THEN
     fileposi=fu
     GOTO listar
    END IF
   END IF
  NEXT

  GOTO listar

RETURN

REM Application Out ------------------------------------------------------------------------------------------------------

Exitprog:
GRAPHIC WINDOW HIDE
END FUNCTION

REM ----------------------------------------------------------------------------------------------------------------

THREAD FUNCTION RedrawGraphics(BYVAL hWin AS LONG) AS DWORD
 GRAPHIC ATTACH hWin,0,REDRAW
 DO
  GRAPHIC GET DC TO hVin
  GRAPHIC REDRAW
  SLEEP 1
 LOOP
END FUNCTION

FUNCTION StaticProc(BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
  SELECT CASE wMsg
   CASE %WM_LBUTTONUP
    lb = 0
   CASE %WM_LBUTTONDOWN

   IF %WM_LBUTTONDOWN AND mousepoint.y<62 AND mousepoint.x>494 THEN lb=0:SendMessage GetParent(hWnd),%WM_NCLBUTTONDOWN,%HTCAPTION, lParam
     lb = 1
   IF mousepoint.y<62 AND mousepoint.x>494 THEN lb=0:SendMessage GetParent(hWnd), %WM_NCLBUTTONDOWN, %HTCAPTION, lParam
   IF mousepoint.y<62 AND mousepoint.x>494 AND lb>0 THEN SendMessage GetParent(hWnd), %WM_NCLBUTTONDOWN, %HTCAPTION, lParam
   CASE %WM_RBUTTONDOWN
    lb=2
   CASE %WM_RBUTTONUP
    lb=0
  END SELECT

  FUNCTION = CallWindowProc(GetProp (GetParent(hWnd), "OldStaticProc"), hWnd, wMsg, wParam, lParam)

 END FUNCTION

FUNCTION CreateHole&(BYVAL hWnd AS LONG, BYVAL hHoleRgn AS LONG) AS LONG
 LOCAL windowRect AS RECT, hWindowRgn, hThisRgn AS LONG
  GetWindowRect hWnd, windowRect
    hWindowRgn = CreateRectRgn(0,0,WindowRect.nRight, WindowRect.nBottom)
    hThisRgn = CreateRectRgn(0,0,0,0)
  CombineRgn hThisRgn, hHoleRgn, hWindowRgn, %RGN_XOR
  SetWindowRgn hWnd, hThisRgn, %TRUE
END FUNCTION


REM ----------------------------------------------------------------------------------------------------------------
REM  End of Melgo SOURCE CODE
REM ----------------------------------------------------------------------------------------------------------------
